package com.accenture.eVote.adminms.dto;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.Objects;

@Data
@AllArgsConstructor
@NoArgsConstructor
public class ListaSchedaPerCandidatiDTO {

    private Long idlista;
    private String descLista;
    private Long territorio;
    private Long territorioPadre;
    private String territorioDesc;
    private String territorioPadreDesc;
    private Long idElezione;

    // Info candidato
    private Long id;
    private String nome;
    private String cognome;

    // Id Scrutinio
    private Long idScrutinio;

    public ListaSchedaPerCandidatiDTO(ListaSchedaDTO listaSchedaDTO, CandidatoSchedaDTO candidatoSchedaDTO) {
        this.idlista = listaSchedaDTO.getIdlista();
        this.descLista = listaSchedaDTO.getDescLista();
        this.territorio = listaSchedaDTO.getTerritorio();
        this.territorioPadre = listaSchedaDTO.getTerritorioPadre();
        this.territorioDesc = listaSchedaDTO.getTerritorioDesc();
        this.territorioPadreDesc = listaSchedaDTO.getTerritorioPadreDesc();
        this.idElezione = listaSchedaDTO.getIdElezione();
        this.nome = candidatoSchedaDTO.getNome();
        this.cognome = candidatoSchedaDTO.getCognome();
        this.id = candidatoSchedaDTO.getId();
        this.idScrutinio = listaSchedaDTO.getIdScrutinio();
    }

    public ListaSchedaPerCandidatiDTO(ListaSchedaPerCandidatiDTO listaSchedaPerCandidatiDTO) {
        this.idlista = listaSchedaPerCandidatiDTO.getIdlista();
        this.descLista = listaSchedaPerCandidatiDTO.getDescLista();
        this.territorio = listaSchedaPerCandidatiDTO.getTerritorio();
        this.territorioPadre = listaSchedaPerCandidatiDTO.getTerritorioPadre();
        this.territorioDesc = listaSchedaPerCandidatiDTO.getTerritorioDesc();
        this.territorioPadreDesc = listaSchedaPerCandidatiDTO.getTerritorioPadreDesc();
        this.idElezione = listaSchedaPerCandidatiDTO.getIdElezione();
        this.nome = listaSchedaPerCandidatiDTO.getNome();
        this.cognome = listaSchedaPerCandidatiDTO.getCognome();
        this.id = listaSchedaPerCandidatiDTO.getId();
        this.idScrutinio = listaSchedaPerCandidatiDTO.getIdScrutinio();
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        ListaSchedaPerCandidatiDTO listaSchedaDTO = (ListaSchedaPerCandidatiDTO) o;
        return Objects.equals(id, listaSchedaDTO.id) && Objects.equals(idScrutinio, listaSchedaDTO.idScrutinio); // il confronto è tra id candidati e non liste
    }

    @Override
    public int hashCode() {
        return Objects.hash(id);
    }
}
