package com.accenture.eVote.adminms.entity;

import com.fasterxml.jackson.annotation.JsonInclude;
import jakarta.persistence.*;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

@Entity
@Table(name = "CF_GERTE_GERARCTERRITORIO")
@Data
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude(JsonInclude.Include.NON_EMPTY)
public class TerritorioGerarchia {

    @Id
    @Column(name = "GERTE_ID_GERARCTERRITORIO_PK")
    private Long id;

    @Column(name = "GERTE_TIPGE_TIPOGERARCHIA", insertable=false, updatable=false)
    private Long idTipoGerarchia;

    @Column(name = "GERTE_TIPTE_TIPOTERRITORIO", insertable=false, updatable=false)
    private Long idTipoTerritorio;

    @Column(name = "GERTE_COD_LIVELLO")
    private String codiceLivello;

    @ManyToOne
    @JoinColumn(name = "GERTE_TIPTE_TIPOTERRITORIO")
    private TerritorioTipo territorioTipo;

    @ManyToOne
    @JoinColumn(name = "GERTE_TIPGE_TIPOGERARCHIA")
    private TerritorioGerarchiaTipo territorioGerarchiaTipo;
}
