package com.accenture.eVote.adminms.repository;

import com.accenture.eVote.adminms.entity.ConfTempoElettorale;
import com.accenture.eVote.adminms.entity.IdConfTempoElettorale;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface ConfTempoElettoraleRepository extends JpaRepository<ConfTempoElettorale, IdConfTempoElettorale> {
    @Query("SELECT c FROM ConfTempoElettorale c, Elezioni e WHERE c.elezione = e.idElezione AND "
    + "e.idDataElezione = ?1 AND c.tipoFinestraTemporale = ?2")
    List<ConfTempoElettorale> findByFinestraDataElezione(Long idDataElezione, Long tipoFinestraTemporale);

    ConfTempoElettorale findByElezioneAndTipoFinestraTemporale(Long idElezione, Long tipoFinestraTemporale);
}


