package com.accenture.eVote.adminms.repository;

import com.accenture.eVote.adminms.entity.ElevoEnte;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;

import java.util.List;

public interface ElevoEnteRepository extends JpaRepository<ElevoEnte, Long> {

    @Query("SELECT count(*) FROM Elettore e " +
            "INNER JOIN ConsensoVoto cv ON e.userId = cv.userId " +
            "INNER JOIN ElevoEnte ee on ee.userId = cv.userId " +
            "WHERE cv.flagConsenso = 1 AND cv.idDataElezione = ?2 " +
            "AND ee.geoId IN ?1 ")
    Long findAllByGeoId(List<String> geoId, Long idDataElezione);
}
