package com.accenture.eVote.adminms.repository;

import com.accenture.eVote.adminms.dto.ElezioneAttivaDTO;
import com.accenture.eVote.adminms.dto.ElezioneEvoteDTO;
import com.accenture.eVote.adminms.entity.Elezioni;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface ElezioniRepository extends JpaRepository<Elezioni, Long> {

    @Query ("SELECT new com.accenture.eVote.adminms.dto.ElezioneAttivaDTO(e.idDataElezione, d.dataElezione, 1L) " +
            "FROM Elezioni e, DateElezioni d " +
            "WHERE e.idDataElezione = d.idDataElezione AND e.codFaseElettorale != ?1")
    List<ElezioneAttivaDTO> getElezioneAttiva(Long valore);

    @Query ("SELECT new com.accenture.eVote.adminms.dto.ElezioneEvoteDTO(d.dataElezione, e.tipologiaElezione, e.codFaseElettorale, " +
            " t.labelDescrizione, e.idDataElezione, e.idElezione) " +
            "FROM Elezioni e, DateElezioni d, TipoElezione t " +
            "WHERE e.idDataElezione = ?1 AND e.idDataElezione = d.idDataElezione AND e.tipologiaElezione = t.idTipoElezione")
    List<ElezioneEvoteDTO> getElezioneByIdDataElezione(Long idDataElezione);

    @Query ("SELECT e.idElezione FROM Elezioni e WHERE e.idDataElezione = ?1")
    List<Long> findIdElezioneByIdDataElezione(Long idDataElezione);

    List<Elezioni> findByIdDataElezione(Long idDataElezione);

    @Query ("SELECT e.codFaseElettorale FROM Elezioni e WHERE e.idDataElezione = ?1")
    List<Long> findCodFaseElettoraleByIdDataElezione(Long idDataElezione);
}

