package com.accenture.eVote.adminms.repository;

import com.accenture.eVote.adminms.entity.Territorio;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface TerritorioRepository extends JpaRepository<Territorio, Long> {

    List<Territorio> findByIdElezioneAndGeoIdPfGuida(Long idElezione, String prefettura);

    @Query("SELECT DISTINCT p.geoId FROM Territorio f " +
            "INNER JOIN Territorio p ON f.territorioPadre.id = p.id " +
            "WHERE f.flagEvote = 'S' AND f.idElezione IN ?1")
    List<String> findGeoIdByIdElezione(List<Long> listIdElezione);

    @Query("SELECT DISTINCT t.geoId FROM Territorio t " +
            "WHERE t.id IN ?1")
    List<String> findGeoIdByListTerritoriPadre(List<Long> listIdTerritorioPadre);

    @Query("SELECT t from Territorio t WHERE t.idElezione IN ?1 AND t.geoIdPfGuida = ?2")
    List<Territorio> findByIdElezioniAndGeoIdPfGuida(List<Long> listIdElezione, String prefettura);

}
