package com.accenture.eVote.adminms.service;

import com.accenture.eVote.adminms.model.Profilo;
import com.accenture.eVote.adminms.model.response.LoginResponse;
import com.accenture.eVote.adminms.util.Crittografia;
import jakarta.servlet.http.HttpServletRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class LoginService {

    @Autowired
    private Crittografia crittografia;

    public LoginResponse login (HttpServletRequest loginRequest){
        LoginResponse loginResponse = new LoginResponse();
        Profilo profilo = new Profilo();
        // recupero informazioni utente da header

        profilo.setIdUtente(loginRequest.getHeader("OAM_REMOTE_USER"));
        profilo.setCodGruppo(Integer.parseInt(loginRequest.getHeader("OAM_CODGRUPPO")));
        profilo.setFlagGruppoUtente(loginRequest.getHeader("OAM_FLAGAPPGRUPPO"));
        profilo.setDescrizione(loginRequest.getHeader("OAM_DESCRIPTION"));
        // genero il token solo se i dati sono presenti
        if(profilo.getCodGruppo() != null && profilo.getDescrizione() != null && profilo.getIdUtente() != null && profilo.getFlagGruppoUtente() != null){
            loginResponse.setJwtToken(crittografia.generaTokenAdmin(profilo));
        }
        return loginResponse;
    }
}
