package com.accenture.eVote.adminms.util;

import com.accenture.eVote.adminms.dto.CandidatoSchedaDTO;
import com.accenture.eVote.adminms.dto.SchedeVotoDTO;
import com.accenture.eVote.adminms.repository.CandidatoRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;
import java.util.Optional;
import java.util.stream.Collectors;

@Component
public class ValidatoreVoti {

    @Autowired
    CandidatoRepository candidatoRepository;

    public List<SchedeVotoDTO> validazioneAlternanzaGenere(List<SchedeVotoDTO> schedeVotoDTOList) {

        List<SchedeVotoDTO> schedaValidaAlternanzaGenere = schedeVotoDTOList.stream()
                //.filter(scheda -> scheda.getBianca().equals(Boolean.FALSE) && scheda.getVotata().equals(Boolean.TRUE))
                .map(schedeVotoDTO -> verificaCandidati(schedeVotoDTO))
                .collect(Collectors.toList());

        return schedaValidaAlternanzaGenere;

    }

    private SchedeVotoDTO verificaCandidati(SchedeVotoDTO schedaVoto) {

        Long candidatiVotatiTotali  = schedaVoto.getLista().getListaCandidati().stream()
                .map(CandidatoSchedaDTO::getId)
                .count();

        // Recupero le informazioni da db dei candidati e verifico che i generi siano distinti
        Long candidatiAleternanzaGenere = schedaVoto.getLista().getListaCandidati().stream()
                .map(candidato -> candidatoRepository.getReferenceById(candidato.getId()).getSesso())
                .distinct()
                .count();

        // il numero in questo caso deve essere uguale a 1 se i votati totali è 1 oppure uguale a 2 se il numero di votati è 2
        // todo da rivedere in caso di preferenze >2
        if (!candidatiAleternanzaGenere.equals(candidatiVotatiTotali)){
            // elimino il secondo voto in quanto non valido per alternanza di genere
            schedaVoto.getLista().getListaCandidati().remove(1);

            return schedaVoto;
        };

        return schedaVoto;

    }
}
