package com.accenture.eVote.apiGateway.util;

import com.accenture.eVote.apiGateway.strategy.AuthStrategy;
import org.springframework.cloud.gateway.filter.GatewayFilterChain;
import org.springframework.stereotype.Component;
import org.springframework.web.server.ServerWebExchange;
import reactor.core.publisher.Mono;

@Component
public class Autenticazione {

    private AuthStrategy authStrategy;

    public void setAuthStrategy(AuthStrategy authStrategy){
        this.authStrategy = authStrategy;
    }

    public Mono<Void> executeStrategy(ServerWebExchange exchange, GatewayFilterChain chain) {
        if (authStrategy != null) {
            return authStrategy.verifica(exchange,chain);
        } else {
            System.out.println("Nessuna strategia specificata.");
            return null;
        }
    }
}
