package com.accenture.eVote.apiGateway.util;

import java.util.Arrays;

public enum EndpointCDA {
    ENDPOINT1("/admin-ms/admin/login"),
    ENDPOINT2("/admin-ms/protected/admin/elezioni/elezione-attiva"),
    ENDPOINT3("/admin-ms/protected/admin/scrutinio/scrutinio-aggregato-cda"),
    ENDPOINT4("/admin-ms/protected/admin/scrutinio/dettaglio-preferenze-liste"),
    ENDPOINT5("/admin-ms/protected/admin/scrutinio/resoconto-scrutinio"),
    ENDPOINT6("/admin-ms/protected/admin/elezioni/trasferisci-dati-siel"),
    ENDPOINT7("/admin-ms/protected/admin/elezioni/date-attive-evote"),
    ENDPOINT8("/admin-ms/protected/admin/elezioni/elettori-digitali-cda"),
    ENDPOINT9("/schede-ms/protected/scheda/votanti-digitali-cda");


    private final String endpoint;

    EndpointCDA(String endpoint) {
        this.endpoint = endpoint;
    }

    public String getEndpoint() {
        return this.endpoint;
    }

    public static boolean verificaEndpoint(String requestEndpoint) {
        return Arrays.stream(values())
                .anyMatch(endpoint -> requestEndpoint.startsWith(endpoint.getEndpoint()));
    }
}
