import { NgModule } from '@angular/core';
import { RouterModule, Routes } from '@angular/router';


const routes: Routes = [
  {
    path: "app",
    loadChildren: () => import('./modules/secured/secured.module').then(m => m.SecuredModule),
  },
  {
    path: "**",
    redirectTo: "app/home",
  }
];

@NgModule({
  imports: [RouterModule.forRoot(routes, { scrollPositionRestoration: 'top' })],
  exports: [RouterModule]
})
export class AppRoutingModule { }
