import { APP_INITIALIZER, NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';

import { AppRoutingModule } from './app-routing.module';
import { AppComponent } from './app.component';

import { TranslateModule,TranslateLoader, TranslateService } from  '@ngx-translate/core';
import { HttpClientModule, HttpClient, HTTP_INTERCEPTORS } from  '@angular/common/http';
import { HttpLoaderFactory } from './modules/shared/shared.module';
import {ResponseInterceptor } from './interceptors/response.interceptor'
import {AuthInterceptor } from './interceptors/auth.interceptor'

import { FormsModule, ReactiveFormsModule } from '@angular/forms';


@NgModule({
  declarations: [
    AppComponent
  ], 
  imports: [
    BrowserModule,
    AppRoutingModule,
    HttpClientModule,
    // FormsModule,
    // ReactiveFormsModule,
    TranslateModule.forRoot({
      loader: {
        provide: TranslateLoader,
        useFactory: HttpLoaderFactory,
        deps: [HttpClient]
      }}), 
      
  ],
  providers: [
    {
      provide: HTTP_INTERCEPTORS,
      useClass: ResponseInterceptor,
      multi: true
    },
    {
      provide: HTTP_INTERCEPTORS,
      useClass: AuthInterceptor,
      multi: true
    },
  ], // TranslateService
  bootstrap: [AppComponent]
})
export class AppModule { }

