import { Injectable } from '@angular/core';
import {
  HttpRequest,
  HttpHandler,
  HttpEvent,
  HttpInterceptor, HttpErrorResponse
} from '@angular/common/http';
import {catchError, map, Observable, tap, throwError} from 'rxjs';

@Injectable()
export class ResponseInterceptor implements HttpInterceptor {

  constructor() {}

  intercept(request: HttpRequest<any>, next: HttpHandler): Observable<HttpEvent<any>> {
    return next.handle(request).pipe(
      catchError((error: HttpErrorResponse) => {
        let errorMessage = 'Errore sconosciuto';
        if (error.error instanceof ErrorEvent) {
          // Errore del client
          errorMessage = `Errore: ${error.error.message}`;
        } else {
          // Errore lato server
          errorMessage = `Errore: ${error.status} - ${error.message || error.statusText}`;
        }
        return throwError(errorMessage);
      })
    );
  }
}
