import { HttpErrorResponse } from '@angular/common/http';
import { Component } from '@angular/core';
import { ActivatedRoute, Router } from '@angular/router';
import { ChiusuraElezioneService } from '../services/chiusura-elezione.service';

@Component({
  selector: 'app-chiusuraelezioni',
  templateUrl: './chiusuraelezioni.component.html',
  styleUrls: ['./chiusuraelezioni.component.css']
})
export class ChiusuraelezioniComponent {
  votersPresent: boolean = false;

  ngOnInit() {
    this.dataFormatted = this.activeRoute.snapshot.params["dataFormatted"];
    this.schedeDaMostrare = JSON.parse(this.activeRoute.snapshot.params["schedaCaricata"]);
    this.stato = this.schedeDaMostrare[0].codFaseElettorale;
    this.hiddenButton = this.schedeDaMostrare[0].codFaseElettorale != 2;
}
  dataFormatted :any;
  schedeDaMostrare:any;

  //modali
  showModal: boolean = false;
  showSecondModal: boolean = false;
  success: boolean = false;
  hiddenButton:boolean = true;
  stato: number = 0;

  constructor(private activeRoute : ActivatedRoute,
    private routing: Router,
    private chiusuraService: ChiusuraElezioneService){

  }
  openModal(){
    this.chiusuraService.getVotantiPresenti().subscribe({
      next: res => {
        this.votersPresent = res.qualifiedAttributesNotUsed > 0;
      },
      error: (error: HttpErrorResponse) => {
        
      }
    });
    this.showModal = true
  }

  closeModal(){
    this.showModal = false;
    this.showSecondModal = false;
    
  }

  confirmClosing(){
    this.chiusuraService.setChiusuraVoto(this.schedeDaMostrare[0].idDataElezione).subscribe({
      next: res => {
        this.success = true;
        this.closeModal();
        this.showSecondModal=true;
      },
      error: (error: HttpErrorResponse) => {
        this.success = false;
        this.closeModal();
        this.showSecondModal=true;
      }
    });
    
  }

  goToHome(){
    this.closeModal();
    this.routing.navigateByUrl('/app/elezioni')
  }

}
