import { Component } from '@angular/core';
import { ResponseSetDataDto } from '../dto/response-set-data.dto';
import { DateInfoSchedeService } from '../services/date-info-schede.service';
import { Router } from '@angular/router';
import { AuthService } from '../services/auth.service';

@Component({
  selector: 'app-elezioni',
  templateUrl: './elezioni.component.html',
  styleUrls: ['./elezioni.component.css']
})
export class ElezioniComponent {

  switchedCard: Boolean;
  switchedToConfirmCard: Boolean;
  infoFinestraAttiva?: ResponseSetDataDto;
  userRole: string = '';

  constructor(private router: Router, private dateInfoService: DateInfoSchedeService, private authService: AuthService) {
    this.switchedCard = false;
    this.switchedToConfirmCard = false;

  }

  ngOnInit() {
    this.userRole = this.authService.getLocalStorage("flagGruppoUtente") || '';
    this.loadElezioniConInfoFinestraAttiva();

  }

  loadElezioniConInfoFinestraAttiva() {
    this.dateInfoService.getElezioniAttive().subscribe(res => {
      this.infoFinestraAttiva = res;


      if (this.isFinestraAttiva() || this.userRole === "CDA") {
        this.router.navigate(['/app/home/selezione-elezione', { schede: JSON.stringify(this.infoFinestraAttiva) }]);
      }

    });
  }

  isFinestraAttiva(): boolean {
    return this.infoFinestraAttiva !== null && this.infoFinestraAttiva !== undefined && this.infoFinestraAttiva.finestraAttiva === 1;
  }

  onIniziaRicerca(value: Boolean) {
    this.switchedCard = value;
  }

  onConfermaRicerca(valueConfirm: Boolean) {
    this.switchedToConfirmCard = valueConfirm;
  }
}
