import { Component } from '@angular/core';
import { ActivatedRoute } from '@angular/router';
import { AuthService } from '../services/auth.service';
import { environment } from 'src/environments/environment';
import { JwtHelperService } from '@auth0/angular-jwt';
import { Token } from '@angular/compiler';
import { CookieService } from 'ngx-cookie-service';
import { throwError } from 'rxjs';
import { HttpErrorResponse } from '@angular/common/http';
import { UserRoleEnum } from '../enum/user-role-enum';



@Component({
  selector: 'app-homepage',
  templateUrl: './homepage.component.html',
  styleUrls: ['./homepage.component.css']
})
export class HomepageComponent {

  token?: string;
  temporaneo?: boolean;
  encryptedText: string = ''; // La tua stringa crittografat
  decryptedText: string = '';
  

  // dcse = M cda = X
  DCSE = UserRoleEnum.DCSE;
  CDA = UserRoleEnum.CDA;
  flagProfilo?: string;
  sessionId?: string;

  constructor(private route: ActivatedRoute, private authService: AuthService, private cookieService: CookieService) { }

  ngOnInit() {

    this.sessionId = this.cookieService.get('SMSESSION');


    this.takeLoginToken();
  }

  takeLoginToken() {

    this.authService.doLogin(this.cookieService.get('SMSESSION')).subscribe({
      next: res => {

        this.token = res.jwtToken;
        this.authService.setLocalStorage("jwtTokenData", res.jwtToken);

        if (this.token && this.token != 'null') {

          //QUESTA PORZIONE DI CODICE E' STATA RIMOSSA PER MOTIVI DI SICUREZZA

          let codgruppoElab;
          this.authService.setLocalStorage('codGruppo', codgruppoElab);


        }

      },
      error(error: HttpErrorResponse) {
        let errorMessage = 'errore durante il recupero info token';
        if (error.error instanceof ErrorEvent) {
          errorMessage = error.error.message;
        } else {
          errorMessage = `Error Code: ${error.status}\nMessage: ${error.message}`;
        }
        return throwError(() => {
          return errorMessage;
        });
      }
    });
    
  }

}
