import { Component, Input, OnInit, Output, EventEmitter } from '@angular/core';
import { Router } from '@angular/router';
import { DateAttiveEvoteResponseDto } from '../dto/date-attive-evote-response.dto';
import { UserRoleEnum } from '../enum/user-role-enum';
import { AuthService } from '../services/auth.service';
import { GestioneConsensoVotoService } from '../services/gestione-consenso.service';

@Component({
  selector: 'app-menuelezioni',
  templateUrl: './menuelezioni.component.html',
  styleUrls: ['./menuelezioni.component.css']
})
export class MenuelezioniComponent {

  @Input()
  dataFormatted?: string = '';

  @Input()
  isElezioni = true;

  @Input()
  isTempielettorali = false;

  @Input()
  schedeCaricate: DateAttiveEvoteResponseDto[] = [];
  
  userRole?: string;

  DCSE = UserRoleEnum.DCSE;
  CDA = UserRoleEnum.CDA;

  constructor(private router: Router, private gestioneConsensoVotoService: GestioneConsensoVotoService, private authService: AuthService) {

  }
  ngOnInit() {
    // dcse = M cda = X
    this.userRole = this.authService.getLocalStorage("flagGruppoUtente") || '';


  }

  gotoModConsenso() {
    this.router.navigate(['app/tempiElettorali/modificaconsensovoto', {dataFormatted : this.dataFormatted, schedaCaricata: JSON.stringify(this.schedeCaricate)}]);
  }

  gotoElezioni() {
    this.router.navigate(['app/elezioni'])
  }





}
