import { NgModule } from '@angular/core';
import { RouterModule, Routes } from '@angular/router';
import { ElezioniComponent } from './elezioni/elezioni.component';
import { GestioneGuidaVotoComponent } from './gestione-guida-voto/gestione-guida-voto.component';
import { HomepageComponent } from './homepage/homepage.component';
import { ModificaconsensovotoComponent } from './modificaconsensovoto/modificaconsensovoto.component';
import { SecuredComponent } from './secured.component';
import { SelezioneDateElezioniComponent } from './selezione-date-elezioni/selezione-date-elezioni.component';
import { SelezioneElezioneComponent } from './selezione-elezione/selezione-elezione.component';
import { GestioneFaseVotoComponent } from './gestione-fase-voto/gestione-fase-voto.component';
import { ChiusuraelezioniComponent } from './chiusuraelezioni/chiusuraelezioni.component';
import { InviodatiComponent } from './inviodati/inviodati.component';
import { ResocontoElezioneComponent } from './resoconto-elezione/resoconto-elezione.component';
import { AuthenticatedGuard } from './../../guards/authenticated.guard'




const routes: Routes = [
  {
    path: "",
    component: SecuredComponent,
    children: [
      { path: "home", component: HomepageComponent },
      {
        path: "elezioni", component: ElezioniComponent,
        // canActivate: [AuthenticatedGuard]
      },
      {
        path: "elezioni/select-date", component: SelezioneDateElezioniComponent,
        // canActivate: [AuthenticatedGuard]
      },
      {
        path: "elezioni/resoconto-elezione", component: ResocontoElezioneComponent,
        // canActivate: [AuthenticatedGuard]
      },
      {
        path: "home/selezione-elezione", component: SelezioneElezioneComponent,
        // canActivate: [AuthenticatedGuard]
      },
      {
        path: "elezioni/gestione-guida-voto", component: GestioneGuidaVotoComponent,
        // canActivate: [AuthenticatedGuard]
      },
      {
        path: "tempiElettorali/modificaconsensovoto", component: ModificaconsensovotoComponent,
        // canActivate: [AuthenticatedGuard]
      },
      {
        path: "tempiElettorali/gestione-fase-voto", component: GestioneFaseVotoComponent,
        // canActivate: [AuthenticatedGuard]
      },
      {
        path: "tempiElettorali/chiusuraelezioni", component: ChiusuraelezioniComponent,
        // canActivate: [AuthenticatedGuard]
      },
      {
        path: "tempiElettorali/inviodati", component: InviodatiComponent,
        // canActivate: [AuthenticatedGuard]
      }


    ]

  }
];

@NgModule({
  imports: [RouterModule.forChild(routes)],
  exports: [RouterModule]
})
export class SecuredRoutingModule { }
