import { APP_INITIALIZER, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';

import { SecuredRoutingModule } from './secured-routing.module';
import { SecuredComponent } from './secured.component';
import { HomepageComponent } from './homepage/homepage.component';
import { SharedModule } from '../shared/shared.module';
import { ElezioniComponent } from './elezioni/elezioni.component';
import { TrovaElezioniComponent } from './trova-elezioni/trova-elezioni.component';
import { TranslateModule } from '@ngx-translate/core';
import { SelezioneDateElezioniComponent } from './selezione-date-elezioni/selezione-date-elezioni.component';
import { SelezioneElezioneComponent } from './selezione-elezione/selezione-elezione.component';
import { GestioneGuidaVotoComponent } from './gestione-guida-voto/gestione-guida-voto.component';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { ModificaconsensovotoComponent } from './modificaconsensovoto/modificaconsensovoto.component';
import { MenuelezioniComponent } from './menuelezioni/menuelezioni.component';
import { NavtempielettoraliComponent } from './navtempielettorali/navtempielettorali.component';
import { GestioneFaseVotoComponent } from './gestione-fase-voto/gestione-fase-voto.component';
import { ChiusuraelezioniComponent } from './chiusuraelezioni/chiusuraelezioni.component';
import { InviodatiComponent } from './inviodati/inviodati.component';
import { ResocontoElezioneComponent } from './resoconto-elezione/resoconto-elezione.component';




@NgModule({
  declarations: [
    SecuredComponent,
    HomepageComponent,
    ElezioniComponent,
    TrovaElezioniComponent,
    SelezioneDateElezioniComponent,
    SelezioneElezioneComponent,
    GestioneGuidaVotoComponent,
    ModificaconsensovotoComponent,
    MenuelezioniComponent,
    NavtempielettoraliComponent,
    GestioneFaseVotoComponent,
    ChiusuraelezioniComponent,
    InviodatiComponent,
    ResocontoElezioneComponent
  ],
  imports: [
    CommonModule,
    SecuredRoutingModule,
    SharedModule,
    TranslateModule,
    FormsModule,
    ReactiveFormsModule
  ]
})
export class SecuredModule { }