import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from '../../../../environments/environment';
import { ChiusuraElezioneDto } from '../dto/chiusura-elezione.dto';

@Injectable({
  providedIn: 'root'
})
export class ChiusuraElezioneService {

  constructor(private http: HttpClient) { }

  getVotantiPresenti(){
    const url = environment.baseHost + environment.getVotantiPresenti;
    return this.http.get<any>(url);
  }

  setChiusuraVoto(idDataElezione: number){
    const url = environment.baseHost + environment.closeElectionPath;
    const param: ChiusuraElezioneDto = new ChiusuraElezioneDto;
    param.idDataElezione = idDataElezione;
    return this.http.post<any>(url, param);
  }
}

