import { Injectable } from '@angular/core';
import { HttpClient } from '@angular/common/http';
import { Observable } from 'rxjs';
import { environment } from '../../../../environments/environment';
import { GuidaVotoDto } from '../dto/guida-voto.dto';

@Injectable({
  providedIn: 'root'
})
export class GestioneGuidaVotoService {

  monthNames = [
    "gennaio", "febbraio", "marzo", "aprile",
    "maggio", "giugno", "luglio", "agosto",
    "settembre", "ottobre", "novembre", "dicembre"];

  constructor(private http: HttpClient) { }

  getGuidaVoto(id: number): Observable<GuidaVotoDto> {
    const url = environment.baseHost + environment.getGuidaVotoUrl + id;
    return this.http.get<GuidaVotoDto>(url);
  }

  setGuidaVoto(guidaVoto: GuidaVotoDto): Observable<GuidaVotoDto> {
    const url = environment.baseHost + environment.setGuidaVotoUrl;
    return this.http.post<GuidaVotoDto>(url, guidaVoto);
  }

  formatDate(dateToFormat: string) {
    var date = new Date(dateToFormat);
    var day = date.getDate();
    const month = this.monthNames[date.getMonth()];
    const year = date.getFullYear();
    return `${day} ${month} ${year}`;

  }
}
