import { Component } from '@angular/core';
import { Router } from '@angular/router';
import { AuthService } from 'src/app/modules/secured/services/auth.service';

@Component({
  selector: 'app-header',
  templateUrl: './header.component.html',
  styleUrls: ['./header.component.css']
})
export class HeaderComponent {

  username: string = '';
  shortUsername: string = '';
  showModal: boolean = false;
  showModal2: boolean = false;


  constructor(private router: Router, private authService: AuthService) {

  }

  ngOnInit() {
   
    this.username = this.authService.getLocalStorage("username") || '';

    this.shortUsername = this.username.split(".")[0];
  }

  isHome = !this.router.url.includes("elezione") && this.router.url.includes("home")


  signOff() {
    this.authService.doLogout();
    this.showModal2 = true;
  }

  openModal() {
    this.showModal = true;
    this.showModal2 = false;

  }

  closeModal() {
    this.showModal = false;
    this.showModal2 = false;

  }

}
