import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { HeaderComponent } from './component/header/header.component';
import { PageLayoutComponent } from './component/page-layout/page-layout.component';
import { FooterComponent } from './component/footer/footer.component';

import { TranslateModule, TranslateLoader, TranslateService } from '@ngx-translate/core';
import { TranslateHttpLoader } from '@ngx-translate/http-loader';
import { HttpClientModule, HttpClient } from '@angular/common/http';


@NgModule({
  declarations: [
    HeaderComponent,
    PageLayoutComponent,
    FooterComponent,
  ],
  imports: [
    CommonModule,
    TranslateModule
  ],
  exports: [
    HeaderComponent,
    PageLayoutComponent,
    FooterComponent,
  ],
})
export class SharedModule { }


export function HttpLoaderFactory(http: HttpClient): TranslateHttpLoader {
  return new TranslateHttpLoader(http,
    './assets/i18n/',
    '.json');
}