import { TranslateModule,TranslateLoader, TranslateService } from  '@ngx-translate/core';
import { TranslateHttpLoader } from  '@ngx-translate/http-loader';
import { HttpClientModule, HttpClient } from  '@angular/common/http';
import { CommonModule } from '@angular/common';

export function HttpLoaderFactory(http: HttpClient) {
    return new TranslateHttpLoader(http,
      './assets/i18n/',
      '.json');
  }

  @NgModule({
    declarations: [],
    imports: [
      CommonModule,
      HttpClientModule,
      TranslateModule.forRoot({
        defaultLanguage: 'it',
        loader: {
          provide: TranslateLoader,
          useFactory: HttpLoaderFactory,
          deps: [HttpClient],
        },
      }),
    ],
    exports: [TranslateModule],
  })
  export default class NgxTranslateModule { }