import { Component, OnInit } from '@angular/core';
import { ActivatedRoute, Router } from '@angular/router';
import { GuidavotoService } from '../../services/guidavoto/guidavoto.service';
import { BreakpointObserver, BreakpointState } from '@angular/cdk/layout';
import {Title} from "@angular/platform-browser";

const SMALL_WIDTH_BK = 720;

@Component({
  selector: 'app-guidavoto',
  templateUrl: './guidavoto.component.html',
  styleUrls: ['./guidavoto.component.scss']
})
export class GuidavotoComponent implements OnInit {
  leftPath = '../../../../voto/assets/homepage/left_blue.png';
  guidavoto: String = "";
  isScreenSmall = false;
  constructor(private router: Router, private service: GuidavotoService, private activatedRoute :ActivatedRoute, private breakpointObserver : BreakpointObserver) {
    document.title = 'Guida al voto area privata | Portale Votazione'
  }
  public getGuidavoto() {
    this.service.getGuidaVoto(this.activatedRoute.snapshot.params['id']).subscribe(
      response => {
        this.guidavoto = response.contenutoGuidaVoto;
      },
      error => {

      }
    );
  }
  ngOnInit(): void {
    this.getGuidavoto()
    this.breakpointObserver.observe([`(max-width:${SMALL_WIDTH_BK}px)`])
      .subscribe((state: BreakpointState) => {
        this.isScreenSmall = state.matches;
      })
  }
  public gotoHome() {
    this.router.navigate(['home']);
  }
}
