import { NgModule } from '@angular/core';
import { RouterModule, Routes } from '@angular/router';
import { ErrorPageComponent } from './components/error-page/error-page.component';
import { GuidavotoComponent } from './components/guidavoto/guidavoto.component';
import { HomepageComponent } from './components/homepage/homepage.component';
import { VotaelencolisteComponent } from './components/votaelencoliste/votaelencoliste.component';
import { SecuredComponent } from './secured.component';

const routes: Routes = [
  {
    path : "",
    component: SecuredComponent,
    children : [
      {path : "error", component :ErrorPageComponent},
      {path : "home", component : HomepageComponent},
      {path : "guidavoto/:id", component : GuidavotoComponent},
      {path : "votaelencoliste", component : VotaelencolisteComponent,
    },

    ]
  }
];

@NgModule({
  imports: [RouterModule.forChild(routes)],
  exports: [RouterModule]
})
export class SecuredRoutingModule { }
