import { Injectable } from '@angular/core';
import { HttpClient } from '@angular/common/http';
import { BehaviorSubject } from 'rxjs';
import { Observable } from 'rxjs';
import { environment } from 'src/environments/environment';


@Injectable({
  providedIn: 'root'
})
export class TimervotoService {
  
 
  
  constructor(private http : HttpClient) { 
    
  } 

  public  getTimerVoto(id : number) {
    const url = `${environment.api2}${environment.getTimer}${id}`;
    return this.http.get<number>(url);
  }

  private tempoScaduto = new BehaviorSubject(false);
  getTempoScaduto(){ 
    return this.tempoScaduto.asObservable()
  }

  setTempoScaduto(value : boolean){
    this.tempoScaduto.next(value);
  }
  private tempoDaPosticipare = new BehaviorSubject(false);
  getTempoDaPosticipare(){ 
    return this.tempoDaPosticipare.asObservable()
  }

  setTempoDaPosticipare(value : boolean){
    this.tempoDaPosticipare.next(value);
  }
}
