import { BreakpointState, BreakpointObserver } from '@angular/cdk/layout';
import { ThisReceiver } from '@angular/compiler';
import { Component, HostListener, OnDestroy, OnInit } from '@angular/core';
import { async } from '@angular/core/testing';
import { ActivatedRoute, NavigationEnd, NavigationStart, Router } from '@angular/router';
import { TimervotoService } from 'src/app/modules/secured/services/timervoto/timervoto.service';
import { environment } from 'src/environments/environment';
//QUESTA PORZIONE DI CODICE E' STATA ELIMINATA PER MOTIVI DI SICUREZZA
import { fromEvent, map, merge, of, Subscription } from 'rxjs';
const SMALL_WIDTH_BK = 1000;
const FULL_DASH_ARRAY = 283;

@Component({
  selector: 'app-header',
  templateUrl: './header.component.html',
  styleUrls: ['./header.component.scss']
})

export class HeaderComponent implements OnInit, OnDestroy {
  networkStatus: boolean = false;
  networkStatus$: Subscription = Subscription.EMPTY;

  showSupport: boolean = false;

  showModal: boolean = false;
  isScreenSmall: boolean = false;
  modalShown: boolean = false;
  isVotoInCorso: boolean = false;
  remainingTime: string = "100%"
  TIME_LIMIT: any = "";
  descScheda = "";
  initialTime: any
  currentTime: any
  isRefresh: boolean = false
  timerScaduto: boolean = false;
  offline: boolean = false;


  @HostListener('window:beforeunload', ['$event'])
  unloadHandler(event: Event): void {
    // Esegui le azioni desiderate prima della chiusura della scheda
    localStorage.removeItem('openCounter');
  }
  @HostListener('offline', ['$event'])
  offlineEvent(event: Event): void {

    localStorage.clear()
    sessionStorage.clear()
    this.offline = true
  }
  @HostListener('document:keydown', ['$event'])
  onEscape(event: KeyboardEvent) {
    if (event.key == "Escape") {
      if (this.showModal) {
        this.showModal = false;
        this.modalShown = true
      }
      else if (this.showSupport) {
        this.showSupport = false;
      }
      else if (this.timerScaduto) {
        this.redirectHome()
      }
      else if (this.offline) {
        window.close()
      }
    }
  }

  openModal() {
    if (!this.modalShown) {
      this.showModal = true;
      this.modalShown = true;
      this.timerService.setTempoDaPosticipare(true)
      setTimeout(() => {
        if (document.querySelector('#myModal') != undefined) {
          document.querySelector<HTMLElement>('#myModal')!.focus()
        }
      }, 20)

    }
  }

  openSupport() {
    this.showSupport = true;
    setTimeout(() => {
      if (document.querySelector('#myModal') != undefined) {
        document.querySelector<HTMLElement>('#myModal')!.focus()
      }
    }, 20)
  }

  closeSupport() {
    this.showSupport = false;
  }

  closeModal() {

    this.showModal = false;

    this.timerService.setTempoDaPosticipare(false)
  }

  redirectHome() {
    this.router.navigateByUrl("voto/app/home")
    this.timerScaduto = false;

  }
  timePassed = 0;
  timeLeft = this.TIME_LIMIT;
  formatTime(time: any) {
    if (this.router.url.includes("votaelencoliste") && this.TIME_LIMIT !== "") {

      if (!navigator.onLine) {
        localStorage.clear()
        sessionStorage.clear()
        this.offline = true
        setTimeout(() => {
          if (document.querySelector('#myModal') != undefined) {
            document.querySelector<HTMLElement>('#myModal')!.focus()
          }
        }, 20)
        this.router.navigateByUrl("voto/app/home")
        this.timerScaduto = false;
      }
      if (time <= 0) {
        this.descScheda = sessionStorage.getItem("ripartizioneScheda")!
        time = 0;

        this.showModal = false;
        this.timerScaduto = true;
        clearInterval(this.timerInterval)
        this.timerService.setTempoScaduto(true)
        setTimeout(() => {
          if (document.querySelector('#myModal') != undefined) {
            document.querySelector<HTMLElement>('#myModal')!.focus()
          }
        }, 20)
      }
      // The largest round integer less than or equal to the result of time divided being by 60.
      const minutes = Math.floor(time / 60);

      // Seconds are the remainder of the time divided by 60 (modulus operator)
      let seconds: any = time % 60;

      // If the value of seconds is less than 10, then display seconds with a leading zero
      if (seconds < 10) {
        seconds = `0${seconds}`;
      }
      if (time / 60 <= 3 && this.router.url.includes("votaelencoliste")) {
        this.remainingPathColor = "orange";
        this.openModal();

      }


      // The output in MM:SS format
      if (minutes > 0 || seconds > 31) {
        if (seconds == 0) {
          if (this.isScreenSmall) {
            return `<div aria-live="polite" alt="${minutes} minuti" ><strong  style="font-size:30px; margin-bottom:8px">${minutes}</strong>
          <span alt="minuti">min</span> &nbsp<strong aria-hidden="true" style="font-size:30px; margin-bottom:8px">${seconds}</strong><span aria-hidden="true"  alt="secondi">sec</span></div>`;
          }
          return `<div aria-live="polite" alt="${minutes} minuti" ><strong  style="font-size:25px; margin-bottom:8px">${minutes}</strong>
        <span alt="minuti">min</span> &nbsp<strong aria-hidden="true" style="font-size:25px; margin-bottom:8px">${seconds}</strong><span aria-hidden="true"  alt="secondi">sec</span></div>`;
        }
        else {
          if (this.isScreenSmall) {
            return `<div alt="${minutes} minuti" ><strong aria-hidden="true" style="font-size:30px; margin-bottom:8px">${minutes}</strong>
          <span alt="minuti" aria-hidden="true" >min</span> &nbsp<strong aria-hidden="true" style="font-size:30px; margin-bottom:8px">${seconds}</strong><span aria-hidden="true"  alt="secondi">sec</span></div>`;
          }
          return `<div alt="${minutes} minuti" ><strong aria-hidden="true" style="font-size:25px; margin-bottom:8px">${minutes}</strong>
        <span alt="minuti">min</span> &nbsp<strong aria-hidden="true" style="font-size:25px; margin-bottom:8px">${seconds}</strong><span aria-hidden="true"  alt="secondi">sec</span></div>`;

        }
      }
      else {
        if (this.isScreenSmall) {
          return `<div aria-live="polite" alt="${seconds} secondi" ><strong aria-hidden="true" style="font-size:30px; margin-bottom:8px">${minutes}</strong>
        <span alt="minuti" aria-hidden="true" >min</span> &nbsp<strong style="font-size:30px; margin-bottom:8px">${seconds}</strong><span alt="secondi">sec</span></div>`;
        }
        return `<div aria-live="polite" alt="${seconds} secondi" ><strong aria-hidden="true" style="font-size:25px; margin-bottom:8px">${minutes}</strong>
      <span alt="minuti" aria-hidden="true" >min</span> &nbsp<strong style="font-size:25px; margin-bottom:8px">${seconds}</strong><span alt="secondi">sec</span></div>`;

      }
    }
    return ""
  }

  addTime() {
    this.initialTime += 180
    this.timePassed -= 180;
    this.timeLeftValue =
      this.formatTime(this.timeLeft)
    this.showModal = false;
    this.remainingPathColor = "white";
    this.remainingTime = (this.timeLeft / this.TIME_LIMIT) * 100 + '%'
    this.timerService.setTempoDaPosticipare(false)
    //QUESTA PORZIONE DI CODICE E' STATA ELIMINATA PER MOTIVI DI SICUREZZA   

  }
   timeLeftValue = 
     this.formatTime(this.timeLeft)
    timerInterval : any;
    remainingPathColor = "";
 
     startTimer() {
      
       this.timerInterval = setInterval(() => {
         
         // The amount of time passed increments by one
         this.currentTime = Math.round(new Date().getTime()/1000)
         this.timePassed = this.currentTime - this.initialTime
         this.timeLeft = this.TIME_LIMIT - this.timePassed;
         this.remainingTime = (this.timeLeft/this.TIME_LIMIT)*100 +'%'

         //QUESTA PORZIONE DI CODICE E' STATA ELIMINATA PER MOTIVI DI SICUREZZA    

         // The time left label is updated
         document.getElementById("base-timer-label")!.innerHTML = this.formatTime(this.timeLeft);
         this.setCircleDasharray();
 
       }, 1000);
     }
 
 
     // Divides time left by the defined time limit.
 calculateTimeFraction() {
   return this.timeLeft / this.TIME_LIMIT;
 }
     
 // Update the dasharray value as time passes, starting with 283
  setCircleDasharray() {
    if (!this.isScreenSmall) {
      const circleDasharray = `${(
        this.calculateTimeFraction() * FULL_DASH_ARRAY
      ).toFixed(0)} 283`;
      document
        .getElementById("base-timer-path-remaining")!
        .setAttribute("stroke-dasharray", circleDasharray);
    }
  }



  ngOnInit(): void {
    this.checkNetworkStatus();
    setInterval(() => {if(!this.networkStatus){
      localStorage.clear();
      sessionStorage.clear();
      this.offline = true}}), 100;
    this.breakpointObserver.observe([`(max-width:${SMALL_WIDTH_BK}px)`])
      .subscribe((state: BreakpointState) => {
        this.isScreenSmall = state.matches;
      })
  }
  constructor(private breakpointObserver: BreakpointObserver, private router: Router, private activeRoute: ActivatedRoute, private timerService: TimervotoService) {




    router.events.subscribe((event) => {

      if (this.router.url.includes('error')) {
        this.showHeader = 'none';
      }
      else {
        this.showHeader = 'block';

      }
      if (event instanceof NavigationEnd) {

        this.isVotoInCorso = router.url.includes("votaelencoliste") ? true : false;
        if (this.isVotoInCorso) {
          let arrayUrl = router.url.split('/');
          let id = 0;
          if (arrayUrl[2].includes('idElezione')) {
            let arrayUrlComma = arrayUrl[2].split(';');
            id = Number.parseInt(arrayUrlComma[1].replace('idElezione=', ''))
          }
          if (sessionStorage.getItem("initialTime") == undefined || sessionStorage.getItem("initialTime") == null) {
            this.timerService.getTimerVoto(id).subscribe(
              data => {
                this.timePassed = 0;
                this.TIME_LIMIT = data
                this.remainingPathColor = "white";
                this.startTimer();
                this.timerService.setTempoDaPosticipare(false)
                this.initialTime = Math.round(new Date().getTime() / 1000);
                this.currentTime = Math.round(new Date().getTime() / 1000);
              },
              error => {
                this.offline = true

              }
            );
          }
          else{

              //QUESTA PORZIONE DI CODICE E' STATA ELIMINATA PER MOTIVI DI SICUREZZA 
               
              this.startTimer();

          }
        }
        else {
          clearInterval(this.timerInterval);
          this.modalShown = false;
          this.showModal = false;
          this.timerService.setTempoScaduto(false)
          sessionStorage.removeItem("initialTime")
          sessionStorage.removeItem("timeLeft")
          sessionStorage.removeItem("tempo")
          sessionStorage.removeItem("modalShown")
          sessionStorage.removeItem("listaSelezionata")

        }
      }
    })



  }

  ngOnDestroy(): void {
    this.networkStatus$.unsubscribe();
  }
  closeOffline() {
    window.close()
  }
  isSafariMobile(): boolean {
    return /iPhone|iPad/.test(navigator.userAgent)
  }
  public showHeader: string = '';

  checkNetworkStatus() {
    this.networkStatus = navigator.onLine;
    this.networkStatus$ = merge(
      of(null),
      fromEvent(window, 'online'),
      fromEvent(window, 'offline')
    )
      .pipe(map(() => navigator.onLine))
      .subscribe(status => {
        this.networkStatus = status;
      });
  }

}