import { BreakpointState, BreakpointObserver } from '@angular/cdk/layout';
import { Component, Input, OnInit } from '@angular/core';
import { Router } from '@angular/router';
const SMALL_WIDTH_BK = 1000;


@Component({
  selector: 'app-timervoto',
  templateUrl: './timervoto.component.html',
  styleUrls: ['./timervoto.component.scss']
})
export class TimervotoComponent implements OnInit{
  ngOnInit(): void {
    this.breakpointObserver.observe([`(max-width:${SMALL_WIDTH_BK}px)`])
    .subscribe((state:BreakpointState) =>{
      this.isScreenSmall= state.matches;
      })
  }
  @Input()
  timeLeft : any;
  @Input()
  timeLeftValue : any;
  @Input()
  remainingPathColor:any;
  @Input()
  remainingTime :string ="100%"
  isScreenSmall: boolean = false;
  constructor(private breakpointObserver: BreakpointObserver, private router : Router){

  }
 
}
