package com.accenture.eVote.elettorims.entity;

import com.fasterxml.jackson.annotation.JsonInclude;
import jakarta.persistence.*;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

@Entity
@Table(name = "CT_TIPCA_TIPICANDIDATURA")
@Data
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude(JsonInclude.Include.NON_EMPTY)
public class TipiCandidatura {

    @Id
    @Column(name = "TIPCA_SEQ_TIPOCANDIDATURA_PK")
    private Long id;

    @Column(name = "TIPCA_DESCR_TIPOCANDIDATURA")
    private String tipoCandidatura;

    @Column(name = "TIPCA_FLAG_SUPPLENTE")
    private String flagSupplente;

    @Column(name = "TIPCA_FLAG_CANDIDATOLISTA")
    private String flagCandidatoLista;

    @Column(name = "TIPCA_FLAG_CANDIDATOCAPOLISTA")
    private String flagCandidatoCapoLista;

    @Column(name = "TIPCA_FLAG_LISTE_COLLEGATE")
    private String flagListeCollegate;

    @Column(name = "TIPCA_FLAG_FINE_INSERIMENTO")
    private String flagFineInserimento;

    @Column(name = "TIPCA_FLAG_NUM_CANDIDATURA")
    private String flagNumCandidatura;

    @Column(name = "TIPCA_FLAG_COLLEGIO")
    private String flagCollegio;

    @Column(name = "TIPCA_FLAG_SOTTOLISTECOLLEGATE")
    private String flagSottoListeCollegate;

    @Column(name = "TIPCA_FLAG_ALTER_GENERE")
    private String flagAlterGenere;

    @Column(name = "TIPCA_FLAG_II_TURNOSINDACO")
    private String flagTurnoSindaco;

    @ManyToOne
    @JoinColumn(name = "TIPCA_TIPCA_TIPOCANDIDATURA")
    private TipiCandidatura candidaturaSecondoTurno;

}
