package com.accenture.eVote.elettorims.mapper;

import com.accenture.eVote.elettorims.dto.ElettoreDTO;
import io.jsonwebtoken.Claims;
import org.mapstruct.Mapper;
import org.springframework.beans.factory.annotation.Value;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.LinkedHashMap;

@Mapper(componentModel = "Spring")
public class ClaimMapper {

    @Value("${formati.request.data}")
    private String formatoData;

    public ElettoreDTO toElettoreDTO(Claims claims) throws ParseException {

        SimpleDateFormat sdf = new SimpleDateFormat(formatoData);
        ElettoreDTO elettoreDTO = new ElettoreDTO();
        LinkedHashMap<String, String> linkedHashMap = (LinkedHashMap<String, String>) claims.get("elettore");

        elettoreDTO.setCognome(linkedHashMap.get("SPID_familyName") != null ? linkedHashMap.get("SPID_familyName").toString() : null);
        elettoreDTO.setNome(linkedHashMap.get("SPID_name") != null ? linkedHashMap.get("SPID_name").toString() : null);
        elettoreDTO.setDataNascita(linkedHashMap.get("SPID_dateOfBirth") != null ? new Date(sdf.parse(linkedHashMap.get("SPID_dateOfBirth").toString()).getTime()) : null);
        elettoreDTO.setLuogoNascita(linkedHashMap.get("SPID_placeOfBirth") != null ? linkedHashMap.get("SPID_placeOfBirth").toString() : null);
        elettoreDTO.setCodiceFiscale(linkedHashMap.get("SPID_fiscalNumber") != null ? linkedHashMap.get("SPID_fiscalNumber").toString() : null);
        elettoreDTO.setEmailPec(linkedHashMap.get("SPID_digitalAddress") != null ? linkedHashMap.get("SPID_digitalAddress").toString() : null);
        elettoreDTO.setSesso(linkedHashMap.get("SPID_gender") != null ? linkedHashMap.get("SPID_gender").toString() : null);
        elettoreDTO.setTelefono(linkedHashMap.get("SPID_mobilePhone") != null ? linkedHashMap.get("SPID_mobilePhone").toString() : null);

        return elettoreDTO;
    }
}
