package com.accenture.eVote.elettorims.service;

import com.accenture.eVote.elettorims.entity.MetodoAutenticazione;
import com.accenture.eVote.elettorims.mapper.MetodoAutenticazioneMapper;
import com.accenture.eVote.elettorims.model.response.MetodoAutenticazioneResponse;
import com.accenture.eVote.elettorims.repository.MetodoAuteticazioneRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import java.nio.charset.StandardCharsets;
import java.util.Base64;
import java.util.Comparator;
import java.util.List;
import java.util.Optional;
import java.util.stream.Collectors;

@Service
public class MetodoAutenticazioneService {
    @Autowired
    private MetodoAuteticazioneRepository metodoAuteticazioneRepository;
    @Autowired
    private MetodoAutenticazioneMapper metodoAutenticazioneMapper;
    @Value("${costanti.flag.yes}")
    private String flagYes;

    public MetodoAutenticazioneResponse getAll() {
        MetodoAutenticazioneResponse metodoAutenticazioneResponse = new MetodoAutenticazioneResponse();
        List<MetodoAutenticazione> metodoAutenticazioneList = metodoAuteticazioneRepository.findAll();

        // Mapping su DTO e filtro metodi autenticazione attivi/validi
        metodoAutenticazioneResponse.setMetodoAutenticazioneList(metodoAutenticazioneList.stream()
                .filter(metodo -> metodo.getFlagValido().equals(flagYes))
                .sorted(Comparator.comparingLong(MetodoAutenticazione::getId))
                .map(metodoAutenticazioneMapper::toDto)
                .collect(Collectors.toList()));

        return metodoAutenticazioneResponse;
    }
}
