import { Component, HostListener } from '@angular/core';

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css']
})
export class AppComponent {
  title = 'elettori';

  @HostListener("document:keydown", ["$event"])
  onTab(e: KeyboardEvent) {
    if (e.key == "Tab") {
      let focusable = document
        .querySelector("body")!
        .querySelectorAll<HTMLElement>("input,button,select,textarea");

      if (document.querySelector("#myModal") != undefined) {
        focusable = document
          .querySelector("#myModal")!
          .querySelectorAll<HTMLElement>("input,button,select,textarea");
      }

      if (focusable.length) {
        let first = focusable[0];
        let last = focusable[focusable.length - 1];
        let shift = e.shiftKey;
        if (shift) {
          if (e.target === first) {
            // shift-tab pressed on first input in dialog
            last.focus();
            e.preventDefault();
          }
        } else {
          if (e.target === last) {
            // tab pressed on last input in dialog
            first.focus();
            e.preventDefault();
          }
        }
      }
    }
  }
  @HostListener("document:click", ["$event"])
  onClickModal(e: Event) {
    if (document.querySelector("#myModal") != undefined) {
      document.querySelector<HTMLElement>("#myModal")!.focus();
    }
  }
}
