import {Component, Input, OnDestroy, OnInit} from '@angular/core';
import {Subscription} from "rxjs";
import {filter} from "rxjs/operators";
import {MessageService} from "../../services/message.service";

@Component({
  selector: 'app-message',
  templateUrl: './message.component.html',
  styleUrls: ['./message.component.css']
})
export class MessageComponent implements OnInit, OnDestroy {
  @Input() fixed = true;
  messageObject: any = {};
  messageSubscription?: Subscription;

  constructor(public messageService: MessageService) {
  }

  ngOnInit(): void {
    this.messageSubscription = this.messageService.getMessage()
      .pipe(
        filter((message) => !!message)
      )
      .subscribe(message => {
          this.messageObject = message;
        }
      )
  }

  ngOnDestroy() {
    this.messageSubscription?.unsubscribe();
  }

}
