import {NgModule} from '@angular/core';
import {RouterModule, Routes} from '@angular/router';
import { LoginFormComponent } from './page/login-form/login-form.component';
import {AuthComponent} from './auth.component';
import { MockLoginComponent } from './page/mock-login/mock-login.component';
import { LoginTabsComponent } from './page/login-tabs/login-tabs.component';
import { WelcomePageComponent } from './page/welcome-page/welcome-page.component';
import { WorkInProgressComponent } from './page/work-in-progress/work-in-progress.component';

const routes: Routes = [
  {
    path: '',
    component: AuthComponent,
    children: [
      {path: 'welcome', component: WorkInProgressComponent},
      {path: 'login', component: WelcomePageComponent},
      {path: 'login/tabs', component: LoginTabsComponent},
      {path: 'login/form', component: LoginFormComponent},
    ]
  },
  
  {path: '**', redirectTo: '/auth/login', pathMatch: 'full'}
];

@NgModule({
  imports: [RouterModule.forChild(routes)],
  exports: [RouterModule]
})
export class AuthRoutingModule {
}
