import {NgModule} from '@angular/core';
import {CommonModule} from '@angular/common';

import {AuthRoutingModule} from './auth-routing.module';
import {AuthComponent} from './auth.component';
import {FormsModule, ReactiveFormsModule} from "@angular/forms";
import { MockLoginComponent } from './page/mock-login/mock-login.component';
import { SharedModule } from '../shared/shared.module';
import { LoginFormComponent } from './page/login-form/login-form.component';
import { LoginTabsComponent } from './page/login-tabs/login-tabs.component';
import { HttpClientModule } from '@angular/common/http';
import { JwtHelperService, JwtModule } from '@auth0/angular-jwt';
import { TranslateModule } from '@ngx-translate/core';
import { WelcomePageComponent } from './page/welcome-page/welcome-page.component';
import { WorkInProgressComponent } from './page/work-in-progress/work-in-progress.component';

@NgModule({
  declarations: [
    AuthComponent,
    MockLoginComponent,
    LoginFormComponent,
    LoginTabsComponent,
    WelcomePageComponent,
    WorkInProgressComponent
  ],
  imports: [
    SharedModule,
    CommonModule,
    AuthRoutingModule,
    FormsModule,
    ReactiveFormsModule,
    HttpClientModule,
    TranslateModule
  ]
})
export class AuthModule {
}
