import { Component } from '@angular/core';
import { FormControl, FormGroup, Validators } from '@angular/forms';
import { UserAireDTO } from './userAireDTO';
import { HttpClient } from '@angular/common/http';
import { NavigationExtras, Router } from '@angular/router';
//import { LoginServiceService } from '../services/login-service.service';
import { Consolato } from '../services/consolato';

@Component({
  selector: 'app-aire-login',
  templateUrl: './aire-login.component.html',
  styleUrls: ['./aire-login.component.css']
})
export class AireLoginComponent {
  
  showModal: boolean = false;
  selectOptions: Array<string> = [];
  formData: any = {dropdown1: null};
  listaConsolati: Consolato[]=[];

  myForm=new FormGroup({
    firstName: new FormControl('', Validators.required),
    lastName: new FormControl('', Validators.required),
    email: new FormControl('', Validators.compose([Validators.required, Validators.email])),
    selector: new FormControl('', Validators.required),
    checkbox1: new FormControl('', Validators.requiredTrue),
    checkbox2: new FormControl('', Validators.requiredTrue),
  });

  constructor(
    private router: Router) {}
  

  onSubmit() {
    // Qui puoi gestire la logica quando il form viene inviato
    if(!this.myForm.valid){
      this.myForm.markAllAsTouched();
    }
    if (this.myForm.valid) {
      // Form is valid, submit the data
     
      const userDTO: UserAireDTO = {
        nome: this.myForm.get('firstName')!.value,
        cognome: this.myForm.get('lastName')!.value,
        mail: this.myForm.get('email')!.value,
        consolatoResidenza: this.myForm.get('selector')!.value
      };
      
      const userId = 1;
      const navigationExtras: NavigationExtras = {
        state: {
          customData: userId
        }
      };
      
      sessionStorage.setItem('userId', JSON.stringify(userId));
      this.openModal();
      
    }
  }

  ngOnInit(){
   
  }

  openModal() {
    this.showModal = true;
  }

  closeModal() {
    this.showModal = false;
  }
}
