import { Component, OnInit } from '@angular/core';
import { FormGroup, FormControl, Validators } from '@angular/forms';
import {BreakpointObserver, BreakpointState} from '@angular/cdk/layout'
import { ActivatedRoute, Router } from '@angular/router';
import { AireOTPDTO } from './aireOTPDTO';
//import { LoginServiceService } from '../services/login-service.service';

const SMALL_WIDTH_BK = '720';

@Component({
  selector: 'app-aireotp',
  templateUrl: './aireotp.component.html',
  styleUrls: ['./aireotp.component.css']
})
export class AireotpComponent implements OnInit {
  receivedData: number=-1;

  showModal: boolean = false;

  compiled:boolean = false;

  isMobile: boolean = false;

  formData: any = {};

  myForm=new FormGroup({
    otp: new FormControl('', Validators.compose([Validators.required, Validators.pattern('[1-9]{6}')])),
  });
  
  constructor(private breakpointObserver: BreakpointObserver,
    private route: ActivatedRoute){
  }

  ngOnInit(): void {

    this.receivedData = JSON.parse(sessionStorage.getItem('userId')!) as number;
    this.myForm.valueChanges.subscribe(otp  => {
 
    })  
    this.breakpointObserver.observe([`(max-width:${SMALL_WIDTH_BK}px)`])
    .subscribe((state:BreakpointState) =>{
      this.isMobile= state.matches;
      })

      
  
  }
  onSubmit() {
    // Qui puoi gestire la logica quando il form viene inviato
    this.myForm.controls['otp'].markAsTouched()
    if(!this.myForm.valid){
      this.compiled = false;
      if(this.myForm.controls['otp'].value != null && this.myForm.controls['otp'].value != '')
      this.openModal()
    }
    if (this.myForm.valid) {
      // // Form is valid, submit the data
      
      this.compiled = true;
      this.openModal()

    }
  }
  

  openModal() {
    this.showModal = true;
  }

  closeModal() {
    this.showModal = false;
  }

}
