import { NgModule } from '@angular/core';
import { RouterModule, Routes } from '@angular/router';
import { FacSimileComponent } from './fac-simile/fac-simile.component';
import { HomepageComponent } from './homepage/homepage.component';
import { SchedeElettoraliAccettateComponent } from './schede-elettorali-accettate/schede-elettorali-accettate.component';
import { SchedeElettoraliComponent } from './schede-elettorali/schede-elettorali.component';
import { SecuredComponent } from './secured.component';
import { StoricoComponent } from './storico/storico.component';
import { RecapPostVotazioneComponent } from './recap-post-votazione/recap-post-votazione.component';



const routes: Routes = [
  {
    path: "",
    component: SecuredComponent,
    children: [
      { path: "home", component: HomepageComponent },
      { path: "storico", component: StoricoComponent },
      { path: "recap", component: RecapPostVotazioneComponent},
      { path: "schede-elettorali", component: SchedeElettoraliComponent },
      { path: "schede-elettorali-accettate", component: SchedeElettoraliAccettateComponent },
      { path: 'schede-elettorali/fac-simile/camera/:id', component: FacSimileComponent },
      { path: 'schede-elettorali/fac-simile/senato/:id', component: FacSimileComponent },
      { path: 'schede-elettorali/fac-simile/altro/:id', component: FacSimileComponent },
      { path: 'schede-elettorali-accettate/fac-simile/camera/:id', component: FacSimileComponent },
      { path: 'schede-elettorali-accettate/fac-simile/senato/:id', component: FacSimileComponent },
      { path: 'schede-elettorali-accettate/fac-simile/altro/:id', component: FacSimileComponent },
    ]
  }
];

@NgModule({
  imports: [RouterModule.forChild(routes)],
  exports: [RouterModule]
})
export class SecuredRoutingModule { }
