import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';

import { SecuredRoutingModule } from './secured-routing.module';
import { SharedModule } from '../shared/shared.module';
import { HomepageComponent } from './homepage/homepage.component';
import { SecuredComponent } from './secured.component';
import { AireotpComponent } from './aireotp/aireotp.component';
import { AireLoginComponent } from './aire-login/aire-login.component';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { HttpClientModule } from '@angular/common/http';
import { HubAccessPageComponent } from './hub-access-page/hub-access-page.component';
import { TranslateModule } from '@ngx-translate/core';
import { StoricoComponent } from './storico/storico.component';
import { RecapPostVotazioneComponent } from './recap-post-votazione/recap-post-votazione.component';
import { SchedeElettoraliComponent } from './schede-elettorali/schede-elettorali.component';
import { FacSimileComponent } from './fac-simile/fac-simile.component';
import { SchedeElettoraliAccettateComponent } from './schede-elettorali-accettate/schede-elettorali-accettate.component';



@NgModule({
  declarations: [
    HomepageComponent,
    SecuredComponent,
    AireotpComponent,
    AireLoginComponent,
    HubAccessPageComponent,
    StoricoComponent,
    RecapPostVotazioneComponent,
    SchedeElettoraliComponent,
    SchedeElettoraliAccettateComponent,
    FacSimileComponent,
  ],
  imports: [
    CommonModule,
    SecuredRoutingModule,
    SharedModule,
    FormsModule,
    ReactiveFormsModule,
    HttpClientModule,
    TranslateModule,
  ]
})
export class SecuredModule { }
