

export class SchedeResponseDto {
    idScheda?: number;
    idElezione?: number;
    idTerritorio?: number;
    numPreferenze?: number;
    alternanzaGenere?: true;
    listaSchedaDTOList?: SchedaDto[];
    candidatoLeaderListe?: CandidatoLeaderListeDto[];
}

export class SchedaDto {

    lista?: ListaDto;
    candidatoLista?: CandidatoDto[];

}

export class CandidatoLeaderListeDto {
    idCandidato?: number;
    idTerritorio?: number;
    numCandidatura?: number;
    idContrassegno?: number;
    idPrgContrassegno?: number;
    candidato?: CandidatoDto;
    contrassegno?: ContrassegnoDto;
    territorio?: TerritorioDto;
}

export class ListaDto {
    id?: number;
    idContrassegno?: number;
    idPrgContrassegno?: number;
    descrizione?: string;
    idListaPadre?: number;
    contrassegno?: ContrassegnoDto;
}

export class CandidatoDto {
    id?: number;
    nome?: string;
    cognome?: string;
    dataNascita?: string;
    sesso?: string;
    luogoNascita?: string;
    codiceFiscale?: string;
    descrizioneAltronome?: string;
    elezioniTipoCandidatura?: ElezioniTipoCandidaturaDto;
    altroNome?: {
        id?: number;
        descrizione?: string
    }
}

export class ContrassegnoDto {
    id?: number;
    idPrgContrassegno?: number;
    idTerritorio?: number;
    descrizione?: string;
    descrizioneImmagine?: string;
    blobImmagine?: [string];
    territorio?: TerritorioDto;
}

export class TerritorioDto {
    id?: number;
    idGerTerritorio?: number;
    idTerritorioPadre?: number;
    idElezione?: number;
    codiceEnteLivello?: string;
    descrizioneEnte?: string;
    flagOspedaliera?: string;
    geoId?: string;
    geoIdPrGuida?: string;
    geoIdPfGuida?: string;
    idTipoTerritorio?: number;
    flagEvote?: string;
    territorioGerarchia?: TerritorioGerarchiaDto;
    territorioPadre?: string;
    elezione?: ElezioneDto;
    territorioTipo?: TerritorioTipoDto;
}

export class ElezioniTipoCandidaturaDto {
    tipiCandidatura?: TipiCandidaturaDto;
    tipoElezioni?: TipoElezioniDto;
}

export class TipiCandidaturaDto {
    id?: number;
    tipoCandidatura?: string;
    flagSupplente?: string;
    flagCandidatoLista?: string;
    flagCandidatoCapoLista?: string;
    flagListeCollegate?: string;
    flagFineInserimento?: string;
    flagNumCandidatura?: string;
    flagCollegio?: string;
    flagSottoListeCollegate?: string;
    flagAlterGenere?: string;
    flagTurnoSindaco?: string;
    candidaturaSecondoTurno?: string;
}

export class TipoElezioniDto{
    id?: number;
    descrizione?: string;
    codiceEvento?: string;
    descrizioneAlternativa?: string;
}

export class TerritorioGerarchiaDto {
    id?: number;
    idTipoGerarchia?: number;
    idTipoTerritorio?: number;
    codiceLivello?: string;
    territorioTipo?: TerritorioTipoDto;
    territorioGerarchiaTipo?: TerritorioGerarchiaTipoDto;
}

export class TerritorioTipoDto {
    id?: number;
    descrizione?: string;
}

export class TerritorioGerarchiaTipoDto {
    id?: number;
    descrizione?: string;
    idGerarchiaTipo?: number;
    territorioGerarchiaTipo?: string;
}

export class ElezioneDto {
    idElezione?: number;
    idDataElezione?: number;
    tipologiaElezione?: number;
    codFaseElettorale?: number;
    tipoElezioni?: TipoElezioniDto;
    dateElezioni?: {
        dataElezioneId?: number;
        dataElezione?: string
    };
    elezioniFaseElettorale?: {
        id?: number;
        descrizione?: string;
    }
}