import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { Router } from '@angular/router';
import { environment } from 'src/environments/environment';

@Injectable({
  providedIn: 'root'
})
export class AuthService {

  constructor(
    private router: Router,
    private http : HttpClient
  ) { }

  setSessionStorage(key: string, value: any) {
    sessionStorage.setItem(key, value);
  }

  getSessionStorage(key: string) {
    return sessionStorage.getItem(key);
  }

  removeSessionStorage(key: string) {
    sessionStorage.removeItem(key);
  }

  mockLoginCall(username : string){
    this.setSessionStorage("JWT", "jwtMock")
    this.setSessionStorage("Username", username)
  }

  doLogout(){
    this.removeSessionStorage("jwtTokenData");
    this.removeSessionStorage("jwtTokenAuth");
    sessionStorage.clear();
    localStorage.clear();
    this.router.navigateByUrl('/auth/login')
  }

  getTokensAfterLogin(token : string){
    return this.http.get<any>(`${environment.api}${environment.loginAuthData}${token}`);
  }

}
