import { Injectable } from '@angular/core';
import {HttpClient} from "@angular/common/http";
import {environment} from "../../environments/environment";

@Injectable({
  providedIn: 'root'
})
export class ConsensoVotoService {

  constructor(
    private http : HttpClient
  ) { }

  getConsenso(){
    return this.http.get<any>(`${environment.api}${environment.trovaConsenso}`); 
  }

  setConsenso(flagConsenso : any){
    flagConsenso = flagConsenso?1:0;
    return this.http.put<any>(`${environment.api}${environment.consensoVoto}`, {flagConsenso});
   }

  getFinestraVoto(){
    return this.http.get<any>(`${environment.api}${environment.consensoVotoTrovaVoto}`);
  }

  getSchede(id : any){
    return this.http.get<any>(`${environment.apiSchede}${environment.schedaId}${id}`);
  }

}
