import { HttpClient } from "@angular/common/http";
import { Injectable } from "@angular/core";
import { environment } from "src/environments/environment";
import { UserAireDTO } from "../modules/secured/aire-login/userAireDTO";
import { AireOTPDTO } from "../modules/secured/aireotp/aireOTPDTO";
import { Consolato } from "../modules/secured/services/consolato";
import { DatiAutocertificazioneDTO } from "../modules/secured/services/dati-autocertificazione-DTO";
import { UserData } from "../modules/secured/services/userData";


@Injectable({
  providedIn: 'root'
})
export class LoginService {

  constructor(private http: HttpClient) { }

  getConsolati() {
    const listaConsolati: Consolato[] = [
      {
        id: "CN12232230203",
        provincia: "Charleroi"
      },
      {
        id: "CN12312310103",
        provincia: "Londra"
      },
      {
        id: "CN12302300603",
        provincia: "Monaco di Baviera"
      },
      {
        id: "CN12492490100",
        provincia: "Stoccolma"
      }
    ];
    return listaConsolati;
  }

  getLoginTypeBE() {
    return this.http.get<any>(`${environment.api}${environment.tipiAutenticazione}`);
  }

  submitAutocertificazione(data: DatiAutocertificazioneDTO) {
    return this.http.post<any>(`${environment.api}${environment.loginAutocertificazione}`, data);
  }

  authUser(userDTO: UserAireDTO) {
    this.http.post<any>(`${environment.api}${environment.loginAire}`, userDTO).subscribe(data => {
      return data.userId
    });
  }

  authUserOtp(userOtpDTO: AireOTPDTO) {
    this.http.post<any>(`${environment.api}${environment.loginOtp}`, userOtpDTO).subscribe(data => {
      return data
    }); 
  }

  loginStressTest(){
    return this.http.post<any>(`${environment.apiFake}${environment.loginFake}`,'');
  }

}
