import { HttpClient, HttpHeaders } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { Router } from '@angular/router';
import { JwtHelperService } from '@auth0/angular-jwt';
import { map, Observable } from 'rxjs';
import { environment } from 'src/environments/environment';
import { ElezioniDTO } from '../modules/secured/services/elezioniDTO';
import { SchedeVotateDto } from '../modules/secured/services/schede-votate.dto';
import { AuthService } from './auth.service';

@Injectable({
  providedIn: 'root'
})
export class PostVotazioneService {
  encryptedText: string = '';
  decryptedText: string = '';
  idVotate: number[] = [];
  idNonVotate: number[] = [];

  constructor(
    private router: Router,
    private http : HttpClient,
    private authService: AuthService
  ) { }

  mockGetSchede(){
    const schede = [
      {
        descrizioneElezione: "Camera Estero",
        votata: true
      },
      {
        descrizioneElezione: "Senato Estero",
        votata: true
      },
      {
        descrizioneElezione: "Altro Estero",
        votata: true
      },
      {
        descrizioneElezione: "Camera Estero",
        votata: false
      },
      {
        descrizioneElezione: "Senato Estero",
        votata: false
      },
      {
        descrizioneElezione: "Altro Estero",
        votata: false
      },
    ];
    return schede;
  }

  hasUserVoted(){
    const url = environment.api + environment.getFlagVoto;
    return this.http.get<any>(url);
  }

  getElezioni(){
    const url = environment.apiSchede + environment.getElezioniPath;
    return this.http.get<any>(url);
  }

  setSchedeVotate(){
    const url = environment.apiSchede + environment.setSchedePath;

    let idSchedeVotate:any;
    let idSchedeNonVotate:any;
    //QUESTA PORZIONE DI CODICE E' STATA RIMOSSA PER MOTIVI DI SICUREZZA 

    for( const id of idSchedeVotate){
      if(id !== ''){ this.idVotate.push(parseInt(id))}
    }

    for( const id of idSchedeNonVotate){
      if(id !== ''){ this.idNonVotate.push(parseInt(id))}
    }

    const schedeVotate: SchedeVotateDto = {
      listaIdSchedeVotate: this.idVotate,
      listaIdSchedeNonVotate: this.idNonVotate,
    }

    return this.http.post<any>(url, schedeVotate);
  }

  checkUserMail(){
    const url = environment.api + environment.checkMailPath;
    return this.http.get<any>(url);
  }

  sendMail(idDataElezione?: any): Observable<any>{
    const url = environment.api + environment.sendMail;
    if(idDataElezione === undefined){
      return this.http.get(url, { headers: {Accept: 'application/pdf'}, params: {}, responseType: 'text' });
    }
    else{
      return this.http.get(url, { headers: {Accept: 'application/pdf'}, params: {idDataElezione: idDataElezione }, responseType: 'text' });
    }
  }

  downloadPDF(idDataElezione?: any): Observable<Blob>{
    const url = environment.api + environment.downlaodPDF;
    var params
    if(idDataElezione === undefined){
      params = {};
    }
    else{
      params = {idDataElezione: idDataElezione };
    }
    return this.http.get(url, {headers: {Accept: 'application/pdf'}, params, responseType: 'blob'// Specifica il tipo di risposta come Blob
    });
  }

  getUserMail(){
    
    //QUESTA PORZIONE DI CODICE E' STATA RIMOSSA PER MOTIVI DI SICUREZZA
    
    if(this.authService.getSessionStorage("jwtTokenData") != null){

      //QUESTA PORZIONE DI CODICE E' STATA RIMOSSA PER MOTIVI DI SICUREZZA

      const helper = new JwtHelperService();
      const decoded = helper.decodeToken(this.decryptedText);
      return decoded.elettore.SPID_digitalAddress;
    }
    return 'mail-non-trovata@mail.com';
  }
}
