import { HttpClient } from "@angular/common/http";
import { Injectable } from "@angular/core";
import { Observable } from "rxjs";
import { environment } from "src/environments/environment";
import { SchedeRequestDto } from "../modules/secured/services/schede-request.dto";
import { SchedaDto } from "../modules/secured/services/scheda.dto";




@Injectable({
  providedIn: 'root'
})

export class VotoService {

  constructor(private http: HttpClient) { }

  getSchede(id: any) {
    return this.http.get<any>(`${environment.apiSchede}${environment.scheda}`, { params: { id } });
  }

  postSchedeElezione(listaSchedeAccettazione: any[]) {
    return this.http.post<any>(`${environment.api}${environment.confermaSchede}`, listaSchedeAccettazione);
  }

  postSchedaSchede(dataElezione: any) {
    return this.http.post<any>(`${environment.apiSchede}${environment.postSchede}`, { dataElezione });
  }

  getSchedeAccettate() {
    return this.http.get<any>(`${environment.apiSchede}${environment.schedeAccettate}`);
  }

  getVerificavoto(){
    return this.http.get<any>(`${environment.api}${environment.verificaVoto}`);
  }

  // Funzione per aggiungere zero davanti a numeri inferiori a 10 per le date
  padZero(num: number | undefined) {
    if (num != undefined) return num < 10 ? '0' + num : num.toString();
    return undefined;
  }

  getDataFormatForBE(dataMillisecondi: any): string {
    var data = new Date(dataMillisecondi);
    var dayStart = data.getDate();
    const monthStart = data.getMonth() + 1;
    const yearStart = data.getFullYear();
    const hourStart = data.getHours();
    const minutesStart = data.getMinutes();
    return yearStart + "-" + this.padZero(monthStart) + "-" + this.padZero(dayStart) + "T" + this.padZero(hourStart) + ":" + this.padZero(minutesStart) + ":00.000Z";
  }

  getAttributoQualificato(userPreferences:any){
    return this.http.post<any>(`${environment.api}${environment.attributoQualificato}`, {userPreferences});
  }

}