package com.accenture.eVote.schedems.entity;

import com.fasterxml.jackson.annotation.JsonInclude;
import jakarta.persistence.*;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.sql.Date;

@Entity
@Table(name = "CL_CANDI_CANDIDATI")
@Data
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude(JsonInclude.Include.NON_EMPTY)
public class Candidato {

    @Id
    @Column(name = "CANDI_SEQ_CANDIDATO_PK")
    private Long id;

    @Column(name = "CANDI_DESCR_NOME")
    private String nome;

    @Column(name = "CANDI_DESCR_COGNOME")
    private String cognome;

    @Column(name = "CANDI_DATA_NASCITA")
    private Date dataNascita;

    @Column(name = "CANDI_DESCR_SESSO")
    private String sesso;

    @Column(name = "CANDI_DESCR_LUOGONASCITA")
    private String luogoNascita;

    @Column(name = "CANDI_CODICE_FISCALE")
    private String codiceFiscale;

    @Column(name = "CANDI_DESCR_ALTRONOME")
    private String descrizioneAltronome;

    @ManyToOne
    @JoinColumns({
            @JoinColumn(name = "CANDI_ELTIP_ELEZIONE", referencedColumnName = "ELTIP_TIPEL_TIPOELEZIONE"),
            @JoinColumn(name = "CANDI_ELTIP_TIPOCANDIDATURA", referencedColumnName = "ELTIP_TIPCA_TIPOCANDIDATURA")
    })
    private ElezioniTipoCandidatura elezioniTipoCandidatura;

    @ManyToOne
    @JoinColumn(name = "CANDI_ALTNO_ALTRONOME")
    private AltroNome altroNome;

}
