package com.accenture.eVote.schedems.entity;

import com.fasterxml.jackson.annotation.JsonInclude;
import jakarta.persistence.*;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

@Entity
@Table(name = "CL_CANLE_CANDIDLEADER")
@Data
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude(JsonInclude.Include.NON_EMPTY)
public class CandidatoLeader {

    @Id
    @Column(name = "CANLE_CANDI_CANDIDATO")
    private Long idCandidato;

    @Id
    @Column(name = "CANLE_TERPA_TERRPARTECIPANTE", insertable=false, updatable=false)
    private Long idTerritorio;

    @Column(name = "CANLE_NUM_CANDIDATURA")
    private Long numCandidatura;

    @Column(name = "CANLE_CONTR_CONTRASSEGNO", insertable=false, updatable=false)
    private Long idContrassegno;

    @Column(name = "CANLE_CONTR_PRG_CONTRASSEGNO", insertable=false, updatable=false)
    private Long idPrgContrassegno;

    @ManyToOne
    @JoinColumn(name = "CANLE_CANDI_CANDIDATO")
    private Candidato candidato;

    @ManyToOne
    @JoinColumns({
            @JoinColumn(name = "CANLE_CONTR_CONTRASSEGNO", referencedColumnName = "CONTR_SEQ_CONTRASSEGNO_PK"),
            @JoinColumn(name = "CANLE_CONTR_PRG_CONTRASSEGNO", referencedColumnName = "CONTR_PRG_CONTRASSEGNO_PK")
    })
    private Contrassegno contrassegno;

    @ManyToOne(fetch = FetchType.EAGER)
    @JoinColumn(name = "CANLE_TERPA_TERRPARTECIPANTE")
    private Territorio territorio;

}
