package com.accenture.eVote.schedems.entity;

import com.fasterxml.jackson.annotation.JsonInclude;
import jakarta.persistence.*;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;

@Entity
@Table(name = "CL_CANLI_CANDID_LISTA")
@Data
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude(JsonInclude.Include.NON_EMPTY)
public class CandidatoLista implements Serializable {

    @Id
    @Column(name = "CANLI_CANDI_CANDIDATO")
    private Long idCandidato;

    @Id
    @Column(name = "CANLI_LISTE_LISTA")
    private Long idLista;

    @Column(name = "CANLI_NUM_CANDIDATURA")
    private Long numCandidatura;

    @ManyToOne
    @JoinColumn(name = "CANLI_CANDI_CANDIDATO")
    private Candidato candidato;

    @ManyToOne
    @JoinColumn(name = "CANLI_LISTE_LISTA")
    private Lista lista;
}
