package com.accenture.eVote.schedems.entity;

import com.fasterxml.jackson.annotation.JsonInclude;
import jakarta.persistence.*;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

@Entity
@Table(name = "CL_CALIS_CANDIDATOLISTA")
@Data
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude(JsonInclude.Include.NON_EMPTY)
public class CandidatoListaTerritorio {

    @Id
    @Column(name = "CALIS_LISTE_LISTA")
    private Long idLista;

    @Id
    @Column(name = "CALIS_CANLE_CANDIDATO")
    private Long idCandidato;

    @Id
    @Column(name = "CALIS_CANLE_TERRPARTECIPANTE")
    private Long idTerritorio;

    @ManyToOne(fetch = FetchType.EAGER)
    @JoinColumn(name = "CALIS_LISTE_LISTA")
    private Lista lista;

    @ManyToOne(fetch = FetchType.EAGER)
    @JoinColumns({
            @JoinColumn(name = "CALIS_CANLE_CANDIDATO", referencedColumnName = "CANLE_CANDI_CANDIDATO"),
            @JoinColumn(name = "CALIS_CANLE_TERRPARTECIPANTE", referencedColumnName = "CANLE_TERPA_TERRPARTECIPANTE")
    })
    private CandidatoLeader candidatoLeader;

}
