package com.accenture.eVote.schedems.entity;

import com.fasterxml.jackson.annotation.JsonInclude;
import jakarta.persistence.*;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;

@Entity
@Table(name = "CL_CONTR_CONTRASSEGNI")
@Data
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude(JsonInclude.Include.NON_EMPTY)
public class Contrassegno implements Serializable {

    @Id
    @Column(name = "CONTR_SEQ_CONTRASSEGNO_PK")
    private Long id;

    @Id
    @Column(name = "CONTR_PRG_CONTRASSEGNO_PK")
    private Long idPrgContrassegno;

    @Column(name = "CONTR_TERPA_TERRPARTECIPANTE", insertable=false, updatable=false)
    private Long idTerritorio;

    @Column(name = "CONTR_DESCR_CONTRASSEGNO")
    private String descrizione;

    @Column(name = "CONTR_DESCR_IMMAGINE")
    private String descrizioneImmagine;

    @Lob
    @Column(name = "CONTR_BLOB_IMMAGINE")
    private byte[] blobImmagine;

    @ManyToOne
    @JoinColumn(name = "CONTR_TERPA_TERRPARTECIPANTE")
    private Territorio territorio;

}
