package com.accenture.eVote.schedems.entity;

import com.accenture.eVote.schedems.entity.id.IdElettoreEnte;
import jakarta.persistence.*;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.sql.Date;

@Entity
@IdClass(IdElettoreEnte.class)
@Table(name = "CL_ELEVE_ELEVOENTE")
@Data
@NoArgsConstructor
@AllArgsConstructor
public class    ElettoreEnte {

    @Id
    @Column(name = "ELEVE_USER_ID_ELETTORE", insertable = false, updatable = false)
    private Long idElettore;

    @Id
    @Column(name = "ELEVE_SEZIONE_GEO_ID", insertable = false, updatable = false)
    private String geoId;

    @Id
    @Column(name = "ELEVE_DATA_INIZIO_VALIDITA")
    private Date dataInizioValidita;

    @Column(name = "ELEVE_DATA_FINE_VALIDITA")
    private Date dataFineValidita;

    @ManyToOne
    @JoinColumn(name = "ELEVE_USER_ID_ELETTORE")
    private Elettore elettore;

    @ManyToOne
    @JoinColumn(name = "ELEVE_SEZIONE_GEO_ID")
    private Ente ente;

}
