package com.accenture.eVote.schedems.entity;

import jakarta.persistence.*;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

@Entity
@Table(name = "CL_ELEZI_ELEZIONI")
@Data
@NoArgsConstructor
@AllArgsConstructor
public class Elezioni {

    @Id
    @Column(name = "ELEZI_ID_ELEZIONE_PK")
    private Long idElezione;

    @Column(name = "ELEZI_DATEL_DATAELEZIONE", insertable = false, updatable = false)
    private Long idDataElezione;

    @Column(name = "ELEZI_TIPEL_TIPOLOGIA_ELEZ", insertable = false, updatable = false)
    private Long tipologiaElezione;

    @Column(name = "ELEZI_COD_FASE_ELETTORALE", insertable = false, updatable = false)
    private Long codFaseElettorale;

    @ManyToOne
    @JoinColumn(name = "ELEZI_TIPEL_TIPOLOGIA_ELEZ")
    private TipoElezioni tipoElezioni;

    @ManyToOne
    @JoinColumn(name = "ELEZI_DATEL_DATAELEZIONE")
    private DateElezioni dateElezioni;

    @ManyToOne
    @JoinColumn(name = "ELEZI_COD_FASE_ELETTORALE")
    private ElezioniFaseElettorale elezioniFaseElettorale;

}
