package com.accenture.eVote.schedems.entity;

import com.fasterxml.jackson.annotation.JsonInclude;
import jakarta.persistence.*;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

@Entity
@Table(name = "CL_LISTE_LISTE")
@Data
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude(JsonInclude.Include.NON_EMPTY)
public class Lista {

    @Id
    @Column(name = "LISTE_SEQ_LISTA_PK")
    private Long id;

    @Column(name = "LISTE_CONTR_CONTRASSEGNO", insertable = false, updatable = false)
    private Long idContrassegno;

    @Column(name = "LISTE_CONTR_PRG_CONTRASSEGNO", insertable = false, updatable = false)
    private Long idPrgContrassegno;

    @Column(name = "LISTE_DESCR_LISTA")
    private String descrizione;

    @Column(name = "LISTE_LISTE_PADRE")
    private Long idListaPadre;

    @ManyToOne
    @JoinColumns({
            @JoinColumn(name = "LISTE_CONTR_CONTRASSEGNO", referencedColumnName = "CONTR_SEQ_CONTRASSEGNO_PK"),
            @JoinColumn(name = "LISTE_CONTR_PRG_CONTRASSEGNO", referencedColumnName = "CONTR_PRG_CONTRASSEGNO_PK")
    })
    private Contrassegno contrassegno;

    @OneToMany
    @JoinColumn(name = "CANLI_LISTE_LISTA")
    private List<CandidatoLista> candidatoLista;

    @OneToMany
    @JoinColumn(name = "CANLI_LISTE_LISTA")
    private List<CoterCoaliTerpa> coterCoaliTerpa;

}
