package com.accenture.eVote.schedems.entity;

import jakarta.persistence.*;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.util.List;

@Entity
@Table(name = "CL_SCHFS_SCHEDAFACSIMILE")
@Data
@NoArgsConstructor
@AllArgsConstructor
public class SchedaFacSimile implements Serializable {

    @Id
    @Column(name = "SCHFS_SEQ_SCHEDAFACSIMILE_PK")
    private Long id;

    @Column(name = "SCHFS_TERPA_TERRPARTECIPANTE", insertable = false, updatable = false)
    private Long idTerritorio;

    @OneToMany(fetch = FetchType.EAGER)
    @JoinColumn(name = "SFSCL_SCHFS_SCHEDAVOTO")
    private List<SchedaFacSimileCandidatiLista> schedaFacSimileCandidatiListas;

    @OneToMany(fetch = FetchType.EAGER)
    @JoinColumn(name = "SFSCA_SCHFS_SCHEDAVOTO")
    private List<SchedaFacSimileCan> schedaFacSimileCans;

    @OneToMany(fetch = FetchType.EAGER)
    @JoinColumn(name = "SFSLI_SCHFS_SCHEDAVOTO")
    private List<SchedaFacSimileLista> schedaFacSimileListas;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "SCHFS_TERPA_TERRPARTECIPANTE")
    private Territorio territorio;


}
