package com.accenture.eVote.schedems.entity;

import com.accenture.eVote.schedems.entity.id.IdSchedaFacSimileCan;
import com.fasterxml.jackson.annotation.JsonInclude;
import jakarta.persistence.*;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;

@Entity
@IdClass(IdSchedaFacSimileCan.class)
@Table(name = "CL_SFSCA_SCHEDAFACSIMILECANLE")
@Data
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude(JsonInclude.Include.NON_EMPTY)
public class SchedaFacSimileCan implements Serializable {

    @Id
    @Column(name = "SFSCA_SCHFS_SCHEDAVOTO")
    private Long idSchedaFacSimile;

    @Id
    @Column(name = "SFSCA_CALIS_CANDIDATO")
    private Long idCandidato;

    @Id
    @Column(name = "SFSCA_CALIS_LISTA")
    private Long idLista;

    @Column(name = "SFSCA_CALIS_TERRPARTECIPANTE", insertable=false, updatable=false)
    private Long idTerritorio;

    @ManyToOne(fetch = FetchType.EAGER)
    @JoinColumns({
            @JoinColumn(name = "SFSCA_CALIS_CANDIDATO", referencedColumnName = "CALIS_CANLE_CANDIDATO"),
            @JoinColumn(name = "SFSCA_CALIS_LISTA", referencedColumnName = "CALIS_LISTE_LISTA"),
            @JoinColumn(name = "SFSCA_CALIS_TERRPARTECIPANTE", referencedColumnName = "CALIS_CANLE_TERRPARTECIPANTE")
    })
    private CandidatoListaTerritorio candidatoLeader;

}
