package com.accenture.eVote.schedems.entity;

import com.accenture.eVote.schedems.entity.id.IdSchedaFacSimileCandidatoLista;
import com.fasterxml.jackson.annotation.JsonInclude;
import jakarta.persistence.*;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;

@Entity
@IdClass(IdSchedaFacSimileCandidatoLista.class)
@Table(name = "CL_SFSCL_SCHEDAFACSIMILECANDIDATILISTA")
@Data
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude(JsonInclude.Include.NON_EMPTY)
public class SchedaFacSimileCandidatiLista implements Serializable {

    @Id
    @Column(name = "SFSCL_SCHFS_SCHEDAVOTO")
    private Long idSchedaFacSimile;

    @Id
    @Column(name = "SFSCL_CANLI_LISTA")
    private Long idLista;

    @Id
    @Column(name = "SFCL_CANLI_CANDIDATO")
    private Long idCandidato;

    @ManyToOne(fetch = FetchType.EAGER)
    @JoinColumns({
            @JoinColumn(name = "SFSCL_CANLI_LISTA", referencedColumnName = "CANLI_LISTE_LISTA"),
            @JoinColumn(name = "SFCL_CANLI_CANDIDATO", referencedColumnName = "CANLI_CANDI_CANDIDATO")
    })
    private CandidatoLista candidatoLista;
}
