package com.accenture.eVote.schedems.entity;

import com.fasterxml.jackson.annotation.JsonInclude;
import jakarta.persistence.*;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

@Entity
@Table(name = "CL_TERPA_TERRPARTECIPANTI")
@Data
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude(JsonInclude.Include.NON_EMPTY)
public class Territorio {

    @Id
    @Column(name = "TERPA_SEQ_TERRPARTECIPANTE_PK")
    private Long id;

    @Column(name = "TERPA_GERTE_GERARCTERRITORIO", insertable=false, updatable=false)
    private Long idGerTerritorio;

    @Column(name = "TERPA_TERPA_TERRPARTECIPANTE", insertable=false, updatable=false)
    private Long idTerritorioPadre;

    @Column(name = "TERPA_ELEZI_ELEZIONE", insertable=false, updatable=false)
    private Long idElezione;

    @Column(name = "TERPA_COD_ENTE_LIVELLO")
    private String codiceEnteLivello;

    @Column(name = "TERPA_DESCR_ENTE")
    private String descrizioneEnte;

    @Column(name = "TERPA_FLAG_OSPEDALIERA")
    private String flagOspedaliera;

    @Column(name = "TERPA_GEO_ID")
    private String geoId;

    @Column(name = "TERPA_GEOID_PRGUIDA")
    private String geoIdPrGuida;

    @Column(name = "TERPA_GEOID_PFGUIDA")
    private String geoIdPfGuida;

    @Column(name = "TERPA_TIPTE_TIPOTERRITORIO", insertable=false, updatable=false)
    private Long idTipoTerritorio;

    @Column(name = "TERPA_FLAG_EVOTE")
    private String flagEvote;

    @ManyToOne
    @JoinColumn(name = "TERPA_GERTE_GERARCTERRITORIO")
    private TerritorioGerarchia territorioGerarchia;

    @OneToOne
    @JoinColumn(name = "TERPA_TERPA_TERRPARTECIPANTE")
    private Territorio territorioPadre;

    @ManyToOne
    @JoinColumn(name = "TERPA_ELEZI_ELEZIONE")
    private Elezioni elezione;

    @ManyToOne
    @JoinColumn(name = "TERPA_TIPTE_TIPOTERRITORIO")
    private TerritorioTipo territorioTipo;

}
