package com.accenture.eVote.schedems.mapper;

import com.accenture.eVote.schedems.dto.CandidatoDTO;
import com.accenture.eVote.schedems.dto.SchedaDTO;
import com.accenture.eVote.schedems.model.response.SchedaVerificaIdResponse;
import org.mapstruct.Mapper;

import java.util.stream.Collectors;

@Mapper(componentModel = "spring")
public class SchedaVerificaIdResponseMapper {

    public SchedaVerificaIdResponse toSchedaVerificaIdResponse(SchedaDTO schedaDTO) {

        SchedaVerificaIdResponse schedaVerificaIdResponse = new SchedaVerificaIdResponse();

        // Setting numero preferenze
        schedaVerificaIdResponse.setNumeroPreferenze(schedaDTO.getNumPreferenze());

        // Setting Id scheda
        schedaVerificaIdResponse.setIdScheda(schedaDTO.getIdScheda());

        // Setting id liste e candidati
        schedaVerificaIdResponse.setMappaListeCandidati(schedaDTO.getListaSchedaDTOList().stream()
                .collect(Collectors.toMap(
                        listaSchedaDTO -> listaSchedaDTO.getLista().getId(),
                        listaSchedaDTO -> listaSchedaDTO.getCandidatoLista().stream()
                                .map(CandidatoDTO::getId)
                                .collect(Collectors.toList())
                )));

        return schedaVerificaIdResponse;
    }
}
