package com.accenture.eVote.schedems.repository;

import com.accenture.eVote.schedems.entity.Elezioni;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface ElezioniRepository extends JpaRepository<Elezioni, Long> {
    List<Elezioni> findByIdDataElezione(Long idDataElezione);

    @Query("SELECT DISTINCT e.idDataElezione " +
            "FROM Elezioni e, DateElezioni d " +
            "WHERE e.idDataElezione = d.dataElezioneId AND e.codFaseElettorale != ?1")
    List<Long> getElezioneAttiva(Long valore);

    @Query("SELECT e FROM Elezioni e " +
            "JOIN Territorio t ON t.idElezione = e.idElezione " +
            "JOIN SchedaFacSimile s ON s.idTerritorio = t.id " +
            "WHERE s.id = ?1")
    Elezioni findElezioneByIdScheda(Long idScheda);
}
