package com.accenture.eVote.schedems.repository;

import com.accenture.eVote.schedems.entity.DateElezioni;
import com.accenture.eVote.schedems.entity.RicevutaScheda;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface RicevutaSchedaRepository extends JpaRepository<RicevutaScheda, Long> {

    @Query("SELECT DISTINCT d FROM DateElezioni d " +
            "JOIN Elezioni e ON e.idDataElezione = d.dataElezioneId " +
            "JOIN Territorio t ON t.idElezione = e.idElezione " +
            "JOIN SchedaFacSimile s ON s.idTerritorio = t.id " +
            "JOIN RicevutaScheda r ON r.schedaId = s.id " +
            "WHERE r.userId = ?1")
    List<DateElezioni> findStoricoDate(Long idUser);

    @Query("SELECT COUNT(DISTINCT s.userId) FROM RicevutaScheda s WHERE s.flagVotato = 'S'")
    Integer countVotanti();

}
