package com.accenture.eVote.schedems.repository;

import com.accenture.eVote.schedems.entity.Territorio;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface TerritorioRepository extends JpaRepository<Territorio, Long> {

    List<Territorio> findByGeoIdIn(@Param("geoIds") List<String> geoIds);

    @Query("SELECT t from Territorio t WHERE t.idElezione IN ?1 AND t.geoIdPfGuida = ?2")
    List<Territorio> findByIdElezioneAndGeoIdPfGuida(List<Long> listIdElezione, String prefettura);

    @Query("SELECT DISTINCT t.geoId FROM Territorio t " +
            "WHERE t.id IN ?1")
    List<String> findGeoIdByListTerritoriPadre(List<Long> listIdTerritorioPadre);
}
