package com.accenture.eVote.urnams;

import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.zip.ZipEntry;
import java.util.zip.ZipInputStream;

@SpringBootApplication
public class UrnaMsApplication {

	public static void main(String[] args) {
		unzip();
		SpringApplication.run(UrnaMsApplication.class, args);
	}

	private static void unzip() {

		String zipFilePath = "/wallet/wallet.zip";  // Percorso del file zip all'interno del container
		String outputDirectory = "/app/wallet";  // Directory in cui verrÃ  estratto il contenuto del file zip

		try {
			File zip = new File(zipFilePath);
			if (! zip.exists()) {
				return;
			}

			File outputDir = new File(outputDirectory);
			if (outputDir.exists()) {
				outputDir.delete();
			}
			outputDir.mkdirs();

			FileInputStream fis = new FileInputStream(zipFilePath);
			ZipInputStream zis = new ZipInputStream(fis);
			ZipEntry zipEntry;

			while ((zipEntry = zis.getNextEntry()) != null) {
				String entryName = zipEntry.getName();
				File entryFile = new File(outputDirectory, entryName);

				if (zipEntry.isDirectory()) {
					entryFile.mkdirs();
				} else {
					new File(entryFile.getParent()).mkdirs();
					FileOutputStream fos = new FileOutputStream(entryFile);

					byte[] buffer = new byte[1024];
					int length;
					while ((length = zis.read(buffer)) > 0) {
						fos.write(buffer, 0, length);
					}
					fos.close();
				}
			}

			zis.close();
			fis.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

}
