package it.evota.generate.repository;

import java.sql.Clob;
import java.util.Optional;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import it.evota.generate.entities.ListaAttrQualBc;

@Repository
public interface ListaAttrQualBcRepository extends JpaRepository<ListaAttrQualBc, Long> {

    @Query("SELECT p from ListaAttrQualBc p where p.attributoQualificante = :attributoQualificante")
    public Optional<ListaAttrQualBc> findByAttributoQualificante(@Param("attributoQualificante") Clob clob);
    
    @Query("SELECT p from ListaAttrQualBc p where p.uservoteid = :uservoteid")
    public Optional<ListaAttrQualBc> findByUservoteid(@Param("uservoteid") String uservoteid);
    
}