package it.evota.generate.util.key;

import java.io.Reader;
import java.security.Key;
import java.security.KeyFactory;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.SecureRandom;
import java.security.spec.EncodedKeySpec;
import java.security.spec.PKCS8EncodedKeySpec;
import java.security.spec.X509EncodedKeySpec;
import java.sql.Clob;


import org.apache.tomcat.util.codec.binary.Base64;
import org.bouncycastle.util.io.pem.PemObject;
import org.bouncycastle.util.io.pem.PemReader;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

@Component
public class RSAKeyPairUtil {

	private static SecureRandom rand = new SecureRandom();
	
	@Value("${encoding.asymmetric}")
	private String encodingAsymmetric;
	
	@Value("${encoding.key.type}")
	private String encodingKeyType;

	public byte[] encrypt(byte[] text, Key k) throws Exception {
		//Codice eliminato per motivi di sicurezza
		return null;
	}

	public byte[] encrypt(String text, Key k) throws Exception {
		return null;
	}

	
	public String decrypt(byte[] encryptedText, Key k) throws Exception {
		//Codice eliminato per motivi di sicurezza
		return null;
	}

	public String decrypt(String text, Key k) throws Exception {
		return null;
	}

	public String randomize(String input) throws NoSuchAlgorithmException {
		input = rand.nextLong() + input + String.valueOf(System.currentTimeMillis());
		MessageDigest md = MessageDigest.getInstance("SHA-256");
		md.update(input.getBytes());
		return Base64.encodeBase64String(md.digest()).replace("=", "").toLowerCase();
	}

	public PublicKey readPublicKeyFromClob(Clob clob) throws Exception {
		try (Reader reader = clob.getCharacterStream()) {
			PemReader pr = new PemReader(reader);
			PemObject k = pr.readPemObject();
			EncodedKeySpec spec = new X509EncodedKeySpec(k.getContent());
			return KeyFactory.getInstance(encodingKeyType).generatePublic(spec);
		}
	}

	public PrivateKey readPrivateKeyFromClob(Clob clob) throws Exception {
		try (Reader reader = clob.getCharacterStream()) {
			PemReader pr = new PemReader(reader);
			PemObject k = pr.readPemObject();
			PKCS8EncodedKeySpec spec = new PKCS8EncodedKeySpec(k.getContent());
			return KeyFactory.getInstance(encodingKeyType).generatePrivate(spec);
		}
	}

}