package it.evota.generate;

import static org.junit.jupiter.api.Assertions.assertTrue;

import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.util.Date;

import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.autoconfigure.web.servlet.AutoConfigureMockMvc;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.http.MediaType;
import org.springframework.test.context.ActiveProfiles;
import org.springframework.test.context.jdbc.Sql;
import org.springframework.test.context.jdbc.SqlMergeMode;
import org.springframework.test.context.jdbc.SqlMergeMode.MergeMode;
import org.springframework.test.web.servlet.MockMvc;
import org.springframework.test.web.servlet.MvcResult;
import org.springframework.test.web.servlet.request.MockMvcRequestBuilders;
import org.springframework.test.web.servlet.result.MockMvcResultMatchers;
import org.springframework.util.StreamUtils;

import com.fasterxml.jackson.databind.ObjectMapper;

import it.evota.generate.dto.GenerateAQResponseType;
import it.evota.generate.entities.ListaCertificati;
import it.evota.generate.repository.ListaAttrQualBcRepository;
import it.evota.generate.repository.ListaCertificatiRepository;
import it.evota.generate.util.dto.FindAQRequestType;
import it.evota.generate.util.exception.EVoteAppException;
import it.evota.generate.util.exception.EVoteAppException.ErrorCode;

@Sql("/sql/testSchema.sql")
@SqlMergeMode(MergeMode.MERGE)
@SpringBootTest(classes = GenerateEVotoApplication.class)
@AutoConfigureMockMvc
@ActiveProfiles("test")
//@WebMvcTest(GenerateQualifyAttributeController.class)
class GenerateEVotoApplicationTests {
	@Autowired
	private MockMvc mockMvc;

	@Autowired
	ListaAttrQualBcRepository repo;

	@Autowired
	private ObjectMapper objectMapper;
	
	@Autowired
	ListaCertificatiRepository repoCert;
	

	

	@Test
	@Disabled
	public void testGenerateToken() throws Exception {
		byte[] requestData = readBinaryDataFromFile("/generateinput.txt");

		MvcResult mvcResult = mockMvc
				.perform(MockMvcRequestBuilders.post("/evote/qa/generate")
						.contentType(MediaType.APPLICATION_OCTET_STREAM).content(requestData))
				.andExpect(MockMvcResultMatchers.status().isOk()).andReturn();

		assertTrue(!repo.findAll().isEmpty());
		GenerateAQResponseType generateAQResponse = objectMapper.readValue(mvcResult.getResponse().getContentAsString(),
				GenerateAQResponseType.class);

		FindAQRequestType findAQRequest = new FindAQRequestType();
		findAQRequest.setQualifiedAttribute(generateAQResponse.getQualifiedAttribute());
		mockMvc.perform(MockMvcRequestBuilders.post("/evote/qa/findByAttributoQualificante")
				.contentType(MediaType.APPLICATION_JSON).content(objectMapper.writeValueAsString(findAQRequest)))
				.andExpect(MockMvcResultMatchers.status().isOk());
	}

	@Sql({ "/sql/testData.sql" })
	@Test
	public void testGenerateTokenGeneratingRequest() {
		//Codice eliminato per motivi di sicurezza
	}

	
	@Test
	public void testGenerateTokenGeneratingNRequest() throws Exception {
		//Codice eliminato per motivi di sicurezza
	}

	private byte[] readBinaryDataFromFile(String filePath) throws IOException {
		InputStream inputStream = getClass().getResourceAsStream(filePath);
		return StreamUtils.copyToByteArray(inputStream);
	}
	
	public void writeBytesToFile(byte[] data, String filePath) throws IOException {
        try (FileOutputStream fos = new FileOutputStream(filePath)) {
            fos.write(data);
        }
    }
	
	@SuppressWarnings("unused")
	private PublicKey readPublicKey(String certificateCode) throws Exception {
		ListaCertificati keyEnt = repoCert
				.findByStartDateIsNullAndEndDateIsNullOrStartDateBeforeAndEndDateAfterAndCertificateCodeEquals(
						new Date(), new Date(), certificateCode);
		if (keyEnt != null) {
			return null;
		} else {
			throw new EVoteAppException(ErrorCode.EVOTE_ERROR_INIT.name(), ErrorCode.EVOTE_ERROR_INIT);
		}
	}

	@SuppressWarnings("unused")
	private PrivateKey readPrivateKey(String certificateCode) throws Exception {
		ListaCertificati keyEnt = repoCert
				.findByStartDateIsNullAndEndDateIsNullOrStartDateBeforeAndEndDateAfterAndCertificateCodeEquals(
						new Date(), new Date(), certificateCode);
		if (keyEnt != null) {
			return null;
		} else {
			throw new EVoteAppException(ErrorCode.EVOTE_ERROR_INIT.name(), ErrorCode.EVOTE_ERROR_INIT);
		}
	}
}
