package com.accenture.eVote.votoms.controller;

import com.accenture.eVote.votoms.dto.GuidaVotoDTO;
import io.github.resilience4j.bulkhead.annotation.Bulkhead;
import io.github.resilience4j.retry.annotation.Retry;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.client.RestTemplate;

@RestController
@RequestMapping("/protected/voto/elezioni")
public class ElezioniController {

    @Value("${url.adminms.getGuidaVoto}")
    private String urlGetGuidaVoto;

    @Autowired
    private RestTemplate restTemplate;

    @GetMapping("guida-voto/{id}")
    @Retry(name = "retry-instance")
    @Bulkhead(name = "bulkhead-instance")
    public ResponseEntity<GuidaVotoDTO> getGuidaVoto (@PathVariable(value="id", required = true )Long idGuidaVoto){
        if(idGuidaVoto == null) {
            throw new IllegalArgumentException("L'id guida voto non può essere null");
        }
        urlGetGuidaVoto = urlGetGuidaVoto+"/"+idGuidaVoto;
        return restTemplate.getForEntity(urlGetGuidaVoto, GuidaVotoDTO.class);
    }
}
