package com.accenture.eVote.votoms.repository;

import com.accenture.eVote.votoms.entity.Territorio;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface TerritorioRepository extends JpaRepository<Territorio, Long> {

    List<Territorio> findByIdElezioneAndGeoIdPfGuida(Long idElezione, String prefettura);

    @Query("SELECT DISTINCT p.geoId FROM Territorio f " +
            "INNER JOIN Territorio p ON f.territorioPadre.id = p.id " +
            "WHERE f.flagEvote = 'S' AND f.idElezione IN ?1")
    List<String> findGeoIdByIdElezione(List<Long> listIdElezione);

    Territorio findByGeoIdAndIdElezione(String geoId, Long idElezione);

    Territorio findByIdTerritorioPadre(Long idTerritorioPadre);
}
