package it.evota.registrate.controller;

import org.apache.logging.log4j.LogManager;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.condition.ConditionalOnExpression;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;

import com.fasterxml.jackson.databind.ObjectMapper;

import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.media.Content;
import io.swagger.v3.oas.annotations.media.Schema;
import io.swagger.v3.oas.annotations.responses.ApiResponse;
import io.swagger.v3.oas.annotations.responses.ApiResponses;
import it.evota.registrate.dto.ErrorResponseType;
import it.evota.registrate.dto.EvoteRequestType;
import it.evota.registrate.dto.EvoteResponseType;
import it.evota.registrate.service.BcRegistrateService;
import it.evota.registrate.util.exception.EVoteAppException;

@RestController
@ConditionalOnExpression("${registrate.enabled:false}")
public class VoteRegistrationController {

	@Autowired
	BcRegistrateService service;

	@Autowired
	private ObjectMapper objectMapper;
	




	@Operation(summary = "Submit a vote")
	@ApiResponses(value = { @ApiResponse(responseCode = "200", description = "Ok", content = {
			@Content(mediaType = "application/json", schema = @Schema(implementation = EvoteResponseType.class)) }),
			@ApiResponse(responseCode = "422", description = "Vote cannot be registered", content = {
					@Content(mediaType = "application/problem+json", schema = @Schema(implementation = ErrorResponseType.class)) }),
			@ApiResponse(responseCode = "500", description = "Internal server error", content = {
					@Content(mediaType = "application/problem+json", schema = @Schema(implementation = ErrorResponseType.class)) }) })
	@PostMapping(value = "/evote/submit", consumes = { MediaType.APPLICATION_OCTET_STREAM_VALUE }, produces = {
			MediaType.APPLICATION_JSON_VALUE, MediaType.APPLICATION_PROBLEM_JSON_VALUE })
	public ResponseEntity<?> submitVote(@RequestBody byte[] data) {
		//Codice eliminato per motivi di sicurezza
		return null;
	}
}