package it.evota.registrate.service;

import java.nio.charset.Charset;
import java.security.PrivateKey;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import org.apache.commons.io.IOUtils;
import org.apache.logging.log4j.LogManager;
import org.apache.tomcat.util.codec.binary.Base64;
import org.hibernate.engine.jdbc.ClobProxy;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import it.evota.registrate.dto.EvoteRequestType;
import it.evota.registrate.dto.EvoteResponseType;
import it.evota.registrate.entities.ListaAttrQualSpesiBc;
import it.evota.registrate.entities.ListaAttrQualSpesiBc.StatusEnum;
import it.evota.registrate.entities.ListaCertificati;
import it.evota.registrate.entities.VotoBc;
import it.evota.registrate.repository.ListaAttrQualSpesiBcRepository;
import it.evota.registrate.repository.ListaCertificatiRepository;
import it.evota.registrate.repository.VotoBcRepository;
import it.evota.registrate.util.exception.EVoteAppException;
import it.evota.registrate.util.exception.EVoteAppException.ErrorCode;
import jakarta.persistence.EntityManager;
import jakarta.persistence.PersistenceContext;

@Service
public class BcRegistrateService {

	@Autowired
	ListaAttrQualSpesiBcRepository repoSpesi;

	@Autowired
	VotoBcRepository votoBcRepository;

	@Autowired
	ListaAttrQualSpesiBcRepository attrQualSpesiBcRepo;

	@Autowired
	ListaCertificatiRepository repoCert;



	@PersistenceContext
	private EntityManager entityManager;


	private PrivateKey bepriv = null;
	private long feprivScadenza = 0;

	private PrivateKey fepriv = null;
	private long beprivScadenza = 0;

	public synchronized void readKeys() throws Exception {
		//Codice eliminato per motivi di sicurezza
	}

	public PrivateKey getFePrivateKey() throws Exception {
		if (fepriv == null || feprivScadenza <= System.currentTimeMillis())
			readKeys();
		return fepriv;
	}

	public PrivateKey getBePrivateKey() throws Exception {
		if (bepriv == null || beprivScadenza <= System.currentTimeMillis())
			readKeys();
		return bepriv;
	}

	@Transactional(propagation = Propagation.REQUIRES_NEW)
	public Long submitVote(EvoteRequestType voteRegistration) throws EVoteAppException {
		//Codice eliminato per motivi di sicurezza
		return null;
	}

	@Transactional
	public EvoteResponseType getVoteSession(Long idrecordVotoBc) throws EVoteAppException {
		try {
			String sessionId = votoBcRepository.getSessionIdentitfier(idrecordVotoBc);

			return new EvoteResponseType(sessionId);
		} catch (Exception e) {
			throw new EVoteAppException(e.getMessage(), ErrorCode.REGISTRATION_ERROR_004);
		}
	}

	private static List<byte[]> splitByteArrays(byte[] byteArray, byte delimiter) {
		List<byte[]> byteArrayList = new ArrayList<>();
		List<Byte> currentSegment = new ArrayList<>();

		for (byte b : byteArray) {
			if (b == delimiter) {
				byte[] segmentArray = new byte[currentSegment.size()];
				for (int i = 0; i < currentSegment.size(); i++) {
					segmentArray[i] = currentSegment.get(i);
				}
				byteArrayList.add(segmentArray);
				currentSegment.clear();
			} else {
				currentSegment.add(b);
			}
		}

		if (!currentSegment.isEmpty()) {
			byte[] segmentArray = new byte[currentSegment.size()];
			for (int i = 0; i < currentSegment.size(); i++) {
				segmentArray[i] = currentSegment.get(i);
			}
			byteArrayList.add(segmentArray);
		}

		return byteArrayList;
	}
}
