package it.evota.registrate.util.exception;

public class EVoteAppException extends Exception {

    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	public enum 
	ErrorCode {
        REGISTRATION_ERROR_001("Token not validated"),
        REGISTRATION_ERROR_002("Token already used"),
        REGISTRATION_ERROR_003("Qualified attribute not valid"), 
        REGISTRATION_ERROR_004("Internal Server Error"),
		FIND_BY_ATTR_QUAL_ERROR_001("Qualified attribute not valid"), 
		VERIFY_ERROR_001("Qualified attribute not found"),
		VERIFY_ERROR_002("Qualified attribute already consumed"), 
		EVOTE_ERROR_REST("Error invoking rest service"),
		EVOTE_ERROR_INIT("Error during app initialization");

		private String description;

		ErrorCode(String description) {
			this.description=description;
		}
		
		public String getDescription() {
			return description;
		}
    }

    private final ErrorCode errorCode;

    public EVoteAppException(String message, ErrorCode errorCode) {
        super(message);
        this.errorCode = errorCode;
    }

    public ErrorCode getErrorCode() {
        return errorCode;
    }
}