package it.evota.validate.repository;

import java.util.Date;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import it.evota.validate.dto.CountAQResultType;
import it.evota.validate.entities.ListaAttrQualSpesiBc;
import it.evota.validate.entities.ListaAttrQualSpesiBc.StatusEnum;

@Repository
public interface ListaAttrQualSpesiBcRepository extends JpaRepository<ListaAttrQualSpesiBc, Long> {
	boolean existsByTokenvoto(String tokenVoto);
	
	@Query("SELECT new it.evota.validate.dto.CountAQResultType(" +
	        "COUNT(CASE WHEN l.status = 'V' THEN 1 END) as qualifiedAttributesTotal, " +
	        "COUNT(CASE WHEN l.status = 'U' AND lv.tokenvoto IS NOT NULL THEN 1 END) as qualifiedAttributesUsed )" +
	        "FROM ListaAttrQualSpesiBc l " +
	        "LEFT JOIN (SELECT DISTINCT tokenvoto as tokenvoto FROM ListaAttrQualSpesiBc WHERE status = 'V' AND (:startDate IS NULL OR createdDate >= :startDate)) lv " +
	        "ON l.tokenvoto = lv.tokenvoto " +
	        "WHERE (:startDate IS NULL OR l.createdDate >= :startDate)")
	CountAQResultType countAttributes(@Param("startDate") Date startDate);
	
	 boolean existsByTokenvotoAndStatus(String tokenVoto, StatusEnum status);
}